
/*
 * This file was generated by the SOM Compiler.
 * FileName: xfldr.h.
 * Generated using:
 *     SOM Precompiler somipc: 2.29.1.2
 *     SOM Emitter emith: 2.41
 */

/*
 * 
 * xfldr.idl:
 *      SOM interface description file for the following
 *      XFolder classes (in this order):
 *          XFolder
 *          XFldStartup
 *          XFldShutdown
 *      and the respective metaclasses.
 * 
 *      Check the other files starting with xf* for the
 *      other XFolder classes.
 * 
 *      XFolder is probably the most complex class of this
 *      package. Not only are context menus manipulated, but
 *      open folder view windows are also subclassed to
 *      introduce additional functionality.
 * 
 *      The XFolder class must always be installed.
 *      Installation of XFldStartup and XFldShutdown is
 *      optional.
 * 
 *      Copyright (C) 1997-99 Ulrich Mller.
 *      This file is part of the XFolder source package.
 *      XFolder is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published
 *      by the Free Software Foundation, in version 2 as it comes in the
 *      "COPYING" file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */


#ifndef SOM_XFolder_h
#define SOM_XFolder_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default.
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef XFolder
#define XFolder SOMObject
#endif
#include <wpfolder.h>

/*
 * Start of user-defined types:
 */
#ifndef SOMClass
    #define SOMClass SOMObject
#endif /* SOMClass */
#ifndef WPFolder
    #define WPFolder SOMObject
#endif /* WPFolder */
#ifndef M_WPObject
    #define M_WPObject SOMObject
#endif /* M_WPObject */
#ifndef WPObject
    #define WPObject SOMObject
#endif /* WPObject */
#ifndef M_WPFileSystem
    #define M_WPFileSystem SOMObject
#endif /* M_WPFileSystem */
#ifndef M_WPFolder
    #define M_WPFolder SOMObject
#endif /* M_WPFolder */
#ifndef M_XFolder
    #define M_XFolder SOMObject
#endif /* M_XFolder */
#ifndef M_XFldStartup
    #define M_XFldStartup SOMObject
#endif /* M_XFldStartup */
#ifndef M_XFldShutdown
    #define M_XFldShutdown SOMObject
#endif /* M_XFldShutdown */
typedef
struct XFolder_FDRSORTINFO {
ULONG ulDefaultSort;

/*
 *  the sort criterion that has the check mark in
 *  the "Sort" submenu; one of the WPSORTKEY_
 *  things defined in the passthru_h stuff below
 */
BOOL fAlwaysSort;
ULONG ulCurrentSort;

/*
 *  apparently, ulCurrentSort is only used by the WPS
 *  if fAlwaysSort == TRUE; in that case, it contains
 *  the current sort criterion, which may be different
 *  than the default one
 */
ULONG ulZero1;
ULONG ulZero2;
ULONG ulZero3;
} XFolder_FDRSORTINFO;
typedef
struct XFolder_FDRSORTINFO* XFolder_PFDRSORTINFO;
typedef
struct XFolder_WPSRGB {
BYTE bBlue,  bGreen,  bRed,  bExtra;
} XFolder_WPSRGB;

/*
 *  FDRLONGARRAY:
 *  original WPS structure stored in folder instance data for
 *  storing various folder view data; it is into this structure
 *  that wpRestoreData writes IDKEY_FDRLONGARRAY data.
 *  On Warp 4, apparently the structure always has a size of 84 bytes
 *  == 21 longs.
 *  On Warp 3, four long's are missing; where therefore have 68 bytes
 *  == 17 longs.
 */
typedef
struct XFolder_FDRLONGARRAY {
ULONG ulIconViewCnrAttrs;
ULONG ulTreeViewCnrAttrs;

/*
 *  offset 0x0008
 */
ULONG ulDetlViewCnrAttrs;

/*
 *  Henk says, always 28 80 30 00
 */
ULONG ulFolderFlag;

/*
 *  Henk says, always 03 02 00 00
 *  offset 0x0010
 */
ULONG ulTreeStyle;

/*
 *  Henk says, always 00 00 00 00
 */
ULONG ulDetailsStyle;

/*
 *  Henk says, always FF FF FF FF
 *  offset 0x0018
 */
struct XFolder_WPSRGB rgbTextBkgndCol;

/*
 *  BB GG RR 00;
 *  this is the same for all views, but it is copied from
 *  some folder background data I don't know; byte 4 is also
 *  used for "transparency" when changed from Details view (duh)
 */
ULONG ul7;

/*
 *  unknown, always EF FF FF FF
 *  offset 0x0020
 */
ULONG ul8;

/*
 *  unknown, always EF FF FF FF
 *  text colors
 */
struct XFolder_WPSRGB rgbIconViewTextCol;

/*
 *  offset 0x0028
 */
ULONG ul10;

/*
 *  unknown, always EF FF FF FF
 */
struct XFolder_WPSRGB rgbTreeViewTextCol;

/*
 *  offset 0x0030
 */
struct XFolder_WPSRGB rgbDetlViewTextCol;
ULONG ul13;

/*
 *  unknown, always 00 00 00 40
 *  offset 0x0038
 */
ULONG ulIconViewTextVisibility;

/*
 *  00 00 00 40: standard,
 *  00 00 00 00: invisible,
 *  01 00 00 00: not transparent
 *  Note that the "transparency" flag is always the same for
 *  all views. rgbTextBkgndCol Byte 4 will be 00 if transparency
 *  is off also.
 */
ULONG ulTreeViewTextVisibility;

/*
 *  the same
 *  offset 0x0040
 */
ULONG ul16;

/*
 *  unknown, always 00 00 00 00
 *  end of structure on Warp 3
 *  the following long's are only available on Warp 4:
 */
ULONG ulMenuBarVisibility;

/*
 *  0 = off, 1 = on, 2 = default
 *  Shadow text colors
 *  offset 0x0048
 */
struct XFolder_WPSRGB rgbIconViewShadowCol;
struct XFolder_WPSRGB rgbTreeViewShadowCol;

/*
 *  offset 0x0050
 */
struct XFolder_WPSRGB rgbDetlViewShadowCol;
} XFolder_FDRLONGARRAY;
typedef
struct XFolder_FDRLONGARRAY* XFolder_PFDRLONGARRAY;

/*
 *  FDRBACKGROUND:
 *  original WPS structure stored in folder instance data for
 *  storing folder background data; I don't know which IDKEY_
 *  corresponds to this, because on Warp 4, something else
 *  seems to be used. This information is from Henk Kelder.
 *  That's 14 bytes altogether.
 */
typedef
struct XFolder_FDRBACKGROUND {
ULONG ul1;
struct XFolder_WPSRGB rgbColor;
BYTE bColorOnly;

/*
 *  0x28 Image, 0x27 Color only
 */
BYTE b9;
BYTE bImageType;

/*
 *  2=Normal,3=tiled,4=scaled
 */
BYTE b10;
BYTE bScaleFactor;
BYTE b12;
} XFolder_FDRBACKGROUND;
typedef
struct XFolder_FDRBACKGROUND* XFolder_PFDRBACKGROUND;

/*
 * 
 *      * New instance methods for XFolder:
 * 
 */

#ifndef SOM_DONT_USE_SHORT_NAMES
#ifndef SOMTGD_FDRSORTINFO
    #ifdef FDRSORTINFO
        #undef FDRSORTINFO
        #define SOMTGD_FDRSORTINFO 1
    #else
        #define FDRSORTINFO XFolder_FDRSORTINFO
    #endif /* FDRSORTINFO */
#endif /* SOMTGD_FDRSORTINFO */

#ifndef SOM_DONT_USE_SHORT_NAMES
#ifndef SOMTGD_PFDRSORTINFO
    #ifdef PFDRSORTINFO
        #undef PFDRSORTINFO
        #define SOMTGD_PFDRSORTINFO 1
    #else
        #define PFDRSORTINFO XFolder_PFDRSORTINFO
    #endif /* PFDRSORTINFO */
#endif /* SOMTGD_PFDRSORTINFO */
#endif /* SOM_DONT_USE_SHORT_NAMES */
#ifndef SOMTGD_WPSRGB
    #ifdef WPSRGB
        #undef WPSRGB
        #define SOMTGD_WPSRGB 1
    #else
        #define WPSRGB XFolder_WPSRGB
    #endif /* WPSRGB */
#endif /* SOMTGD_WPSRGB */
#ifndef SOMTGD_FDRLONGARRAY
    #ifdef FDRLONGARRAY
        #undef FDRLONGARRAY
        #define SOMTGD_FDRLONGARRAY 1
    #else
        #define FDRLONGARRAY XFolder_FDRLONGARRAY
    #endif /* FDRLONGARRAY */
#endif /* SOMTGD_FDRLONGARRAY */

#ifndef SOM_DONT_USE_SHORT_NAMES
#ifndef SOMTGD_PFDRLONGARRAY
    #ifdef PFDRLONGARRAY
        #undef PFDRLONGARRAY
        #define SOMTGD_PFDRLONGARRAY 1
    #else
        #define PFDRLONGARRAY XFolder_PFDRLONGARRAY
    #endif /* PFDRLONGARRAY */
#endif /* SOMTGD_PFDRLONGARRAY */
#endif /* SOM_DONT_USE_SHORT_NAMES */
#ifndef SOMTGD_FDRBACKGROUND
    #ifdef FDRBACKGROUND
        #undef FDRBACKGROUND
        #define SOMTGD_FDRBACKGROUND 1
    #else
        #define FDRBACKGROUND XFolder_FDRBACKGROUND
    #endif /* FDRBACKGROUND */
#endif /* SOMTGD_FDRBACKGROUND */

#ifndef SOM_DONT_USE_SHORT_NAMES
#ifndef SOMTGD_PFDRBACKGROUND
    #ifdef PFDRBACKGROUND
        #undef PFDRBACKGROUND
        #define SOMTGD_PFDRBACKGROUND 1
    #else
        #define PFDRBACKGROUND XFolder_PFDRBACKGROUND
    #endif /* PFDRBACKGROUND */
#endif /* SOMTGD_PFDRBACKGROUND */
#endif /* SOM_DONT_USE_SHORT_NAMES */
#endif /* SOM_DONT_USE_SHORT_NAMES */

/*
 * End of user-defined types.
 */

/*
 * Passthru lines: File: "C.h", "after"
 */


#define XFolder_MajorVersion 1
#define XFolder_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define XFolderNewClass xfc
#pragma linkage(xfc, system)
#define XFolderClassData xfd
#define XFolderCClassData xfx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */

/*
 * Include the meta class file
 */
#include <xfldr.h>
/*--------------Migration------------*/
#define XFolder_classObj XFolderClassData.classObject
#define _XFolder XFolder_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK XFolderNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(XFolderNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct XFolderClassDataStructure {
	SOMAny *classObject;
	somMToken xf_withdrawn1;
	somMToken xfUpdateAllFrameWndTitles;
	somMToken xfSnapToGrid;
	somMToken xfQueryFldrSort;
	somMToken xfSetFldrSort;
	somMToken xfSortViewOnce;
	somMToken xfGetIconPos;
	somMToken xfInvalidateOrderedContent;
	somMToken xfUpdateOrderedContent;
	somMToken xfQueryOrderedContent;
	somMToken xfBeginProcessOrderedContent;
	somMToken xfCancelProcessOrderedContent;
	somMToken xfMakeFavoriteFolder;
	somMToken xfIsFavoriteFolder;
	somMToken xfSetQuickOpen;
	somMToken xfQueryQuickOpen;
	somMToken xfShowStatusBar;
	somMToken xfSetStatusBarVisibility;
	somMToken xfQueryStatusBarVisibility;
	somMToken xfForEachOpenView;
	somMToken xfAddXFolderPages;
	somMToken xfSetCnrSort;
} SOMDLINK XFolderClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct XFolderCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} SOMDLINK XFolderCClassData;

/*
 * New and Renew macros for XFolder
 */
#define XFolderNew() \
   (_somNew(_XFolder ? _XFolder : XFolderNewClass(XFolder_MajorVersion, XFolder_MinorVersion)))
#define XFolderRenew(buf) \
   (_somRenew(_XFolder ? _XFolder : XFolderNewClass(XFolder_MajorVersion, XFolder_MinorVersion), buf))

/*
 * Override method: wpInitData
 */
#define XFolder_wpInitData(somSelf) \
	WPObject_wpInitData(somSelf)

/*
 * Override method: wpUnInitData
 */
#define XFolder_wpUnInitData(somSelf) \
	WPObject_wpUnInitData(somSelf)

/*
 * Override method: wpFree
 */
#define XFolder_wpFree(somSelf) \
	WPObject_wpFree(somSelf)

/*
 * Override method: wpSetup
 */
#define XFolder_wpSetup(somSelf,pszSetupString) \
	WPObject_wpSetup(somSelf,pszSetupString)

/*
 * Override method: wpSaveState
 */
#define XFolder_wpSaveState(somSelf) \
	WPObject_wpSaveState(somSelf)

/*
 * Override method: wpRestoreState
 */
#define XFolder_wpRestoreState(somSelf,ulReserved) \
	WPObject_wpRestoreState(somSelf,ulReserved)

/*
 * Override method: wpRestoreLong
 */
#define XFolder_wpRestoreLong(somSelf,pszClass,ulKey,pulValue) \
	WPObject_wpRestoreLong(somSelf,pszClass,ulKey,pulValue)

/*
 * Override method: wpRestoreData
 */
#define XFolder_wpRestoreData(somSelf,pszClass,ulKey,pValue,pcbValue) \
	WPObject_wpRestoreData(somSelf,pszClass,ulKey,pValue,pcbValue)

/*
 * Override method: wpAddSettingsPages
 */
#define XFolder_wpAddSettingsPages(somSelf,hwndNotebook) \
	WPObject_wpAddSettingsPages(somSelf,hwndNotebook)

/*
 * Override method: wpAddFolderSortPage
 */
#define XFolder_wpAddFolderSortPage(somSelf,hwndNotebook) \
	WPFolder_wpAddFolderSortPage(somSelf,hwndNotebook)

/*
 * Override method: wpFilterPopupMenu
 */
#define XFolder_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,fMultiSelect) \
	WPObject_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,fMultiSelect)

/*
 * Override method: wpModifyPopupMenu
 */
#define XFolder_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition) \
	WPObject_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition)

/*
 * Override method: wpMenuItemSelected
 */
#define XFolder_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId) \
	WPObject_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId)

/*
 * Override method: wpMenuItemHelpSelected
 */
#define XFolder_wpMenuItemHelpSelected(somSelf,MenuId) \
	WPObject_wpMenuItemHelpSelected(somSelf,MenuId)

/*
 * Override method: wpOpen
 */
#define XFolder_wpOpen(somSelf,hwndCnr,ulView,param) \
	WPObject_wpOpen(somSelf,hwndCnr,ulView,param)

/*
 * Override method: wpRefresh
 */
#define XFolder_wpRefresh(somSelf,ulView,pReserved) \
	WPFileSystem_wpRefresh(somSelf,ulView,pReserved)

/*
 * Override method: wpSetFldrAttr
 */
#define XFolder_wpSetFldrAttr(somSelf,Attr,ulView) \
	WPFolder_wpSetFldrAttr(somSelf,Attr,ulView)

/*
 * Override method: wpQueryFldrAttr
 */
#define XFolder_wpQueryFldrAttr(somSelf,ulView) \
	WPFolder_wpQueryFldrAttr(somSelf,ulView)

/*
 * Override method: wpAddToContent
 */
#define XFolder_wpAddToContent(somSelf,Object) \
	WPFolder_wpAddToContent(somSelf,Object)

/*
 * Override method: wpDeleteFromContent
 */
#define XFolder_wpDeleteFromContent(somSelf,Object) \
	WPFolder_wpDeleteFromContent(somSelf,Object)

/*
 * Override method: wpStoreIconPosData
 */
#define XFolder_wpStoreIconPosData(somSelf,pIconPos,cbSize) \
	WPFolder_wpStoreIconPosData(somSelf,pIconPos,cbSize)

/*
 * Override method: wpMoveObject
 */
#define XFolder_wpMoveObject(somSelf,Folder) \
	WPObject_wpMoveObject(somSelf,Folder)

/*
 * Override method: wpSetTitle
 */
#define XFolder_wpSetTitle(somSelf,pszNewTitle) \
	WPObject_wpSetTitle(somSelf,pszNewTitle)

/*
 * Override method: wpSetFldrSort
 */
#define XFolder_wpSetFldrSort(somSelf,pSortRecord,ulView,ulType) \
	WPFolder_wpSetFldrSort(somSelf,pSortRecord,ulView,ulType)

/*
 * Override method: wpQueryDefaultHelp
 */
#define XFolder_wpQueryDefaultHelp(somSelf,pHelpPanelId,HelpLibrary) \
	WPObject_wpQueryDefaultHelp(somSelf,pHelpPanelId,HelpLibrary)

/*
 * New Method: xfUpdateAllFrameWndTitles
 */
typedef BOOL   SOMLINK somTP_XFolder_xfUpdateAllFrameWndTitles(XFolder *somSelf);
#pragma linkage(somTP_XFolder_xfUpdateAllFrameWndTitles, system)
typedef somTP_XFolder_xfUpdateAllFrameWndTitles *somTD_XFolder_xfUpdateAllFrameWndTitles;
#define somMD_XFolder_xfUpdateAllFrameWndTitles "::XFolder::xfUpdateAllFrameWndTitles"
#define XFolder_xfUpdateAllFrameWndTitles(somSelf) \
    (SOM_Resolve(somSelf, XFolder, xfUpdateAllFrameWndTitles) \
	(somSelf))
#ifndef SOMGD_xfUpdateAllFrameWndTitles
    #if (defined(_xfUpdateAllFrameWndTitles) || defined(__xfUpdateAllFrameWndTitles))
        #undef _xfUpdateAllFrameWndTitles
        #undef __xfUpdateAllFrameWndTitles
        #define SOMGD_xfUpdateAllFrameWndTitles 1
    #else
        #define _xfUpdateAllFrameWndTitles XFolder_xfUpdateAllFrameWndTitles
    #endif /* _xfUpdateAllFrameWndTitles */
#endif /* SOMGD_xfUpdateAllFrameWndTitles */

/*
 * New Method: xfSnapToGrid
 */
typedef BOOL   SOMLINK somTP_XFolder_xfSnapToGrid(XFolder *somSelf,
		BOOL fNotify);
#pragma linkage(somTP_XFolder_xfSnapToGrid, system)
typedef somTP_XFolder_xfSnapToGrid *somTD_XFolder_xfSnapToGrid;
#define somMD_XFolder_xfSnapToGrid "::XFolder::xfSnapToGrid"
#define XFolder_xfSnapToGrid(somSelf,fNotify) \
    (SOM_Resolve(somSelf, XFolder, xfSnapToGrid) \
	(somSelf,fNotify))
#ifndef SOMGD_xfSnapToGrid
    #if (defined(_xfSnapToGrid) || defined(__xfSnapToGrid))
        #undef _xfSnapToGrid
        #undef __xfSnapToGrid
        #define SOMGD_xfSnapToGrid 1
    #else
        #define _xfSnapToGrid XFolder_xfSnapToGrid
    #endif /* _xfSnapToGrid */
#endif /* SOMGD_xfSnapToGrid */

/*
 * New Method: xfQueryFldrSort
 */
typedef BOOL   SOMLINK somTP_XFolder_xfQueryFldrSort(XFolder *somSelf,
		PUSHORT pusDefaultSort,
		PUSHORT pusAlwaysSort);
#pragma linkage(somTP_XFolder_xfQueryFldrSort, system)
typedef somTP_XFolder_xfQueryFldrSort *somTD_XFolder_xfQueryFldrSort;
#define somMD_XFolder_xfQueryFldrSort "::XFolder::xfQueryFldrSort"
#define XFolder_xfQueryFldrSort(somSelf,pusDefaultSort,pusAlwaysSort) \
    (SOM_Resolve(somSelf, XFolder, xfQueryFldrSort) \
	(somSelf,pusDefaultSort,pusAlwaysSort))
#ifndef SOMGD_xfQueryFldrSort
    #if (defined(_xfQueryFldrSort) || defined(__xfQueryFldrSort))
        #undef _xfQueryFldrSort
        #undef __xfQueryFldrSort
        #define SOMGD_xfQueryFldrSort 1
    #else
        #define _xfQueryFldrSort XFolder_xfQueryFldrSort
    #endif /* _xfQueryFldrSort */
#endif /* SOMGD_xfQueryFldrSort */

/*
 * New Method: xfSetFldrSort
 */
typedef BOOL   SOMLINK somTP_XFolder_xfSetFldrSort(XFolder *somSelf,
		USHORT usDefaultSort,
		USHORT usAlwaysSort);
#pragma linkage(somTP_XFolder_xfSetFldrSort, system)
typedef somTP_XFolder_xfSetFldrSort *somTD_XFolder_xfSetFldrSort;
#define somMD_XFolder_xfSetFldrSort "::XFolder::xfSetFldrSort"
#define XFolder_xfSetFldrSort(somSelf,usDefaultSort,usAlwaysSort) \
    (SOM_Resolve(somSelf, XFolder, xfSetFldrSort) \
	(somSelf,usDefaultSort,usAlwaysSort))
#ifndef SOMGD_xfSetFldrSort
    #if (defined(_xfSetFldrSort) || defined(__xfSetFldrSort))
        #undef _xfSetFldrSort
        #undef __xfSetFldrSort
        #define SOMGD_xfSetFldrSort 1
    #else
        #define _xfSetFldrSort XFolder_xfSetFldrSort
    #endif /* _xfSetFldrSort */
#endif /* SOMGD_xfSetFldrSort */

/*
 * New Method: xfSetCnrSort
 */
typedef void   SOMLINK somTP_XFolder_xfSetCnrSort(XFolder *somSelf,
		HWND hwndCnr,
		BOOL fForce);
#pragma linkage(somTP_XFolder_xfSetCnrSort, system)
typedef somTP_XFolder_xfSetCnrSort *somTD_XFolder_xfSetCnrSort;
#define somMD_XFolder_xfSetCnrSort "::XFolder::xfSetCnrSort"
#define XFolder_xfSetCnrSort(somSelf,hwndCnr,fForce) \
    (SOM_Resolve(somSelf, XFolder, xfSetCnrSort) \
	(somSelf,hwndCnr,fForce))
#ifndef SOMGD_xfSetCnrSort
    #if (defined(_xfSetCnrSort) || defined(__xfSetCnrSort))
        #undef _xfSetCnrSort
        #undef __xfSetCnrSort
        #define SOMGD_xfSetCnrSort 1
    #else
        #define _xfSetCnrSort XFolder_xfSetCnrSort
    #endif /* _xfSetCnrSort */
#endif /* SOMGD_xfSetCnrSort */

/*
 * New Method: xfSortViewOnce
 */
typedef BOOL   SOMLINK somTP_XFolder_xfSortViewOnce(XFolder *somSelf,
		HWND hwndFrame,
		USHORT usSort);
#pragma linkage(somTP_XFolder_xfSortViewOnce, system)
typedef somTP_XFolder_xfSortViewOnce *somTD_XFolder_xfSortViewOnce;
#define somMD_XFolder_xfSortViewOnce "::XFolder::xfSortViewOnce"
#define XFolder_xfSortViewOnce(somSelf,hwndFrame,usSort) \
    (SOM_Resolve(somSelf, XFolder, xfSortViewOnce) \
	(somSelf,hwndFrame,usSort))
#ifndef SOMGD_xfSortViewOnce
    #if (defined(_xfSortViewOnce) || defined(__xfSortViewOnce))
        #undef _xfSortViewOnce
        #undef __xfSortViewOnce
        #define SOMGD_xfSortViewOnce 1
    #else
        #define _xfSortViewOnce XFolder_xfSortViewOnce
    #endif /* _xfSortViewOnce */
#endif /* SOMGD_xfSortViewOnce */

/*
 * New Method: xfGetIconPos
 */
typedef BOOL   SOMLINK somTP_XFolder_xfGetIconPos(XFolder *somSelf,
		WPObject* pObject,
		PBYTE pICONPOS,
		USHORT usICONPOSSize,
		PICONPOS pipReturn);
#pragma linkage(somTP_XFolder_xfGetIconPos, system)
typedef somTP_XFolder_xfGetIconPos *somTD_XFolder_xfGetIconPos;
#define somMD_XFolder_xfGetIconPos "::XFolder::xfGetIconPos"
#define XFolder_xfGetIconPos(somSelf,pObject,pICONPOS,usICONPOSSize,pipReturn) \
    (SOM_Resolve(somSelf, XFolder, xfGetIconPos) \
	(somSelf,pObject,pICONPOS,usICONPOSSize,pipReturn))
#ifndef SOMGD_xfGetIconPos
    #if (defined(_xfGetIconPos) || defined(__xfGetIconPos))
        #undef _xfGetIconPos
        #undef __xfGetIconPos
        #define SOMGD_xfGetIconPos 1
    #else
        #define _xfGetIconPos XFolder_xfGetIconPos
    #endif /* _xfGetIconPos */
#endif /* SOMGD_xfGetIconPos */

/*
 * New Method: xfInvalidateOrderedContent
 */
typedef BOOL   SOMLINK somTP_XFolder_xfInvalidateOrderedContent(XFolder *somSelf);
#pragma linkage(somTP_XFolder_xfInvalidateOrderedContent, system)
typedef somTP_XFolder_xfInvalidateOrderedContent *somTD_XFolder_xfInvalidateOrderedContent;
#define somMD_XFolder_xfInvalidateOrderedContent "::XFolder::xfInvalidateOrderedContent"
#define XFolder_xfInvalidateOrderedContent(somSelf) \
    (SOM_Resolve(somSelf, XFolder, xfInvalidateOrderedContent) \
	(somSelf))
#ifndef SOMGD_xfInvalidateOrderedContent
    #if (defined(_xfInvalidateOrderedContent) || defined(__xfInvalidateOrderedContent))
        #undef _xfInvalidateOrderedContent
        #undef __xfInvalidateOrderedContent
        #define SOMGD_xfInvalidateOrderedContent 1
    #else
        #define _xfInvalidateOrderedContent XFolder_xfInvalidateOrderedContent
    #endif /* _xfInvalidateOrderedContent */
#endif /* SOMGD_xfInvalidateOrderedContent */

/*
 * New Method: xfUpdateOrderedContent
 */
typedef BOOL   SOMLINK somTP_XFolder_xfUpdateOrderedContent(XFolder *somSelf);
#pragma linkage(somTP_XFolder_xfUpdateOrderedContent, system)
typedef somTP_XFolder_xfUpdateOrderedContent *somTD_XFolder_xfUpdateOrderedContent;
#define somMD_XFolder_xfUpdateOrderedContent "::XFolder::xfUpdateOrderedContent"
#define XFolder_xfUpdateOrderedContent(somSelf) \
    (SOM_Resolve(somSelf, XFolder, xfUpdateOrderedContent) \
	(somSelf))
#ifndef SOMGD_xfUpdateOrderedContent
    #if (defined(_xfUpdateOrderedContent) || defined(__xfUpdateOrderedContent))
        #undef _xfUpdateOrderedContent
        #undef __xfUpdateOrderedContent
        #define SOMGD_xfUpdateOrderedContent 1
    #else
        #define _xfUpdateOrderedContent XFolder_xfUpdateOrderedContent
    #endif /* _xfUpdateOrderedContent */
#endif /* SOMGD_xfUpdateOrderedContent */

/*
 * New Method: xfQueryOrderedContent
 */
typedef WPObject*   SOMLINK somTP_XFolder_xfQueryOrderedContent(XFolder *somSelf,
		WPObject* Object,
		ULONG ulOption);
#pragma linkage(somTP_XFolder_xfQueryOrderedContent, system)
typedef somTP_XFolder_xfQueryOrderedContent *somTD_XFolder_xfQueryOrderedContent;
#define somMD_XFolder_xfQueryOrderedContent "::XFolder::xfQueryOrderedContent"
#define XFolder_xfQueryOrderedContent(somSelf,Object,ulOption) \
    (SOM_Resolve(somSelf, XFolder, xfQueryOrderedContent) \
	(somSelf,Object,ulOption))
#ifndef SOMGD_xfQueryOrderedContent
    #if (defined(_xfQueryOrderedContent) || defined(__xfQueryOrderedContent))
        #undef _xfQueryOrderedContent
        #undef __xfQueryOrderedContent
        #define SOMGD_xfQueryOrderedContent 1
    #else
        #define _xfQueryOrderedContent XFolder_xfQueryOrderedContent
    #endif /* _xfQueryOrderedContent */
#endif /* SOMGD_xfQueryOrderedContent */

/*
 * New Method: xfBeginProcessOrderedContent
 */
typedef ULONG   SOMLINK somTP_XFolder_xfBeginProcessOrderedContent(XFolder *somSelf,
		ULONG ulTiming,
		PFNWP pfnwpCallback,
		ULONG ulCallbackParam);
#pragma linkage(somTP_XFolder_xfBeginProcessOrderedContent, system)
typedef somTP_XFolder_xfBeginProcessOrderedContent *somTD_XFolder_xfBeginProcessOrderedContent;
#define somMD_XFolder_xfBeginProcessOrderedContent "::XFolder::xfBeginProcessOrderedContent"
#define XFolder_xfBeginProcessOrderedContent(somSelf,ulTiming,pfnwpCallback,ulCallbackParam) \
    (SOM_Resolve(somSelf, XFolder, xfBeginProcessOrderedContent) \
	(somSelf,ulTiming,pfnwpCallback,ulCallbackParam))
#ifndef SOMGD_xfBeginProcessOrderedContent
    #if (defined(_xfBeginProcessOrderedContent) || defined(__xfBeginProcessOrderedContent))
        #undef _xfBeginProcessOrderedContent
        #undef __xfBeginProcessOrderedContent
        #define SOMGD_xfBeginProcessOrderedContent 1
    #else
        #define _xfBeginProcessOrderedContent XFolder_xfBeginProcessOrderedContent
    #endif /* _xfBeginProcessOrderedContent */
#endif /* SOMGD_xfBeginProcessOrderedContent */

/*
 * New Method: xfCancelProcessOrderedContent
 */
typedef BOOL   SOMLINK somTP_XFolder_xfCancelProcessOrderedContent(XFolder *somSelf,
		ULONG hPOC);
#pragma linkage(somTP_XFolder_xfCancelProcessOrderedContent, system)
typedef somTP_XFolder_xfCancelProcessOrderedContent *somTD_XFolder_xfCancelProcessOrderedContent;
#define somMD_XFolder_xfCancelProcessOrderedContent "::XFolder::xfCancelProcessOrderedContent"
#define XFolder_xfCancelProcessOrderedContent(somSelf,hPOC) \
    (SOM_Resolve(somSelf, XFolder, xfCancelProcessOrderedContent) \
	(somSelf,hPOC))
#ifndef SOMGD_xfCancelProcessOrderedContent
    #if (defined(_xfCancelProcessOrderedContent) || defined(__xfCancelProcessOrderedContent))
        #undef _xfCancelProcessOrderedContent
        #undef __xfCancelProcessOrderedContent
        #define SOMGD_xfCancelProcessOrderedContent 1
    #else
        #define _xfCancelProcessOrderedContent XFolder_xfCancelProcessOrderedContent
    #endif /* _xfCancelProcessOrderedContent */
#endif /* SOMGD_xfCancelProcessOrderedContent */

/*
 * New Method: xfMakeFavoriteFolder
 */
typedef ULONG   SOMLINK somTP_XFolder_xfMakeFavoriteFolder(XFolder *somSelf,
		BOOL fInsert);
#pragma linkage(somTP_XFolder_xfMakeFavoriteFolder, system)
typedef somTP_XFolder_xfMakeFavoriteFolder *somTD_XFolder_xfMakeFavoriteFolder;
#define somMD_XFolder_xfMakeFavoriteFolder "::XFolder::xfMakeFavoriteFolder"
#define XFolder_xfMakeFavoriteFolder(somSelf,fInsert) \
    (SOM_Resolve(somSelf, XFolder, xfMakeFavoriteFolder) \
	(somSelf,fInsert))
#ifndef SOMGD_xfMakeFavoriteFolder
    #if (defined(_xfMakeFavoriteFolder) || defined(__xfMakeFavoriteFolder))
        #undef _xfMakeFavoriteFolder
        #undef __xfMakeFavoriteFolder
        #define SOMGD_xfMakeFavoriteFolder 1
    #else
        #define _xfMakeFavoriteFolder XFolder_xfMakeFavoriteFolder
    #endif /* _xfMakeFavoriteFolder */
#endif /* SOMGD_xfMakeFavoriteFolder */

/*
 * New Method: xfIsFavoriteFolder
 */
typedef BOOL   SOMLINK somTP_XFolder_xfIsFavoriteFolder(XFolder *somSelf);
#pragma linkage(somTP_XFolder_xfIsFavoriteFolder, system)
typedef somTP_XFolder_xfIsFavoriteFolder *somTD_XFolder_xfIsFavoriteFolder;
#define somMD_XFolder_xfIsFavoriteFolder "::XFolder::xfIsFavoriteFolder"
#define XFolder_xfIsFavoriteFolder(somSelf) \
    (SOM_Resolve(somSelf, XFolder, xfIsFavoriteFolder) \
	(somSelf))
#ifndef SOMGD_xfIsFavoriteFolder
    #if (defined(_xfIsFavoriteFolder) || defined(__xfIsFavoriteFolder))
        #undef _xfIsFavoriteFolder
        #undef __xfIsFavoriteFolder
        #define SOMGD_xfIsFavoriteFolder 1
    #else
        #define _xfIsFavoriteFolder XFolder_xfIsFavoriteFolder
    #endif /* _xfIsFavoriteFolder */
#endif /* SOMGD_xfIsFavoriteFolder */

/*
 * New Method: xfSetQuickOpen
 */
typedef ULONG   SOMLINK somTP_XFolder_xfSetQuickOpen(XFolder *somSelf,
		BOOL fQuickOpen);
#pragma linkage(somTP_XFolder_xfSetQuickOpen, system)
typedef somTP_XFolder_xfSetQuickOpen *somTD_XFolder_xfSetQuickOpen;
#define somMD_XFolder_xfSetQuickOpen "::XFolder::xfSetQuickOpen"
#define XFolder_xfSetQuickOpen(somSelf,fQuickOpen) \
    (SOM_Resolve(somSelf, XFolder, xfSetQuickOpen) \
	(somSelf,fQuickOpen))
#ifndef SOMGD_xfSetQuickOpen
    #if (defined(_xfSetQuickOpen) || defined(__xfSetQuickOpen))
        #undef _xfSetQuickOpen
        #undef __xfSetQuickOpen
        #define SOMGD_xfSetQuickOpen 1
    #else
        #define _xfSetQuickOpen XFolder_xfSetQuickOpen
    #endif /* _xfSetQuickOpen */
#endif /* SOMGD_xfSetQuickOpen */

/*
 * New Method: xfQueryQuickOpen
 */
typedef BOOL   SOMLINK somTP_XFolder_xfQueryQuickOpen(XFolder *somSelf);
#pragma linkage(somTP_XFolder_xfQueryQuickOpen, system)
typedef somTP_XFolder_xfQueryQuickOpen *somTD_XFolder_xfQueryQuickOpen;
#define somMD_XFolder_xfQueryQuickOpen "::XFolder::xfQueryQuickOpen"
#define XFolder_xfQueryQuickOpen(somSelf) \
    (SOM_Resolve(somSelf, XFolder, xfQueryQuickOpen) \
	(somSelf))
#ifndef SOMGD_xfQueryQuickOpen
    #if (defined(_xfQueryQuickOpen) || defined(__xfQueryQuickOpen))
        #undef _xfQueryQuickOpen
        #undef __xfQueryQuickOpen
        #define SOMGD_xfQueryQuickOpen 1
    #else
        #define _xfQueryQuickOpen XFolder_xfQueryQuickOpen
    #endif /* _xfQueryQuickOpen */
#endif /* SOMGD_xfQueryQuickOpen */

/*
 * New Method: xfShowStatusBar
 */
typedef HWND   SOMLINK somTP_XFolder_xfShowStatusBar(XFolder *somSelf,
		PVOID psli,
		BOOL fShow);
#pragma linkage(somTP_XFolder_xfShowStatusBar, system)
typedef somTP_XFolder_xfShowStatusBar *somTD_XFolder_xfShowStatusBar;
#define somMD_XFolder_xfShowStatusBar "::XFolder::xfShowStatusBar"
#define XFolder_xfShowStatusBar(somSelf,psli,fShow) \
    (SOM_Resolve(somSelf, XFolder, xfShowStatusBar) \
	(somSelf,psli,fShow))
#ifndef SOMGD_xfShowStatusBar
    #if (defined(_xfShowStatusBar) || defined(__xfShowStatusBar))
        #undef _xfShowStatusBar
        #undef __xfShowStatusBar
        #define SOMGD_xfShowStatusBar 1
    #else
        #define _xfShowStatusBar XFolder_xfShowStatusBar
    #endif /* _xfShowStatusBar */
#endif /* SOMGD_xfShowStatusBar */

/*
 * New Method: xfSetStatusBarVisibility
 */
typedef BOOL   SOMLINK somTP_XFolder_xfSetStatusBarVisibility(XFolder *somSelf,
		ULONG ulVisibility,
		BOOL fUpdate);
#pragma linkage(somTP_XFolder_xfSetStatusBarVisibility, system)
typedef somTP_XFolder_xfSetStatusBarVisibility *somTD_XFolder_xfSetStatusBarVisibility;
#define somMD_XFolder_xfSetStatusBarVisibility "::XFolder::xfSetStatusBarVisibility"
#define XFolder_xfSetStatusBarVisibility(somSelf,ulVisibility,fUpdate) \
    (SOM_Resolve(somSelf, XFolder, xfSetStatusBarVisibility) \
	(somSelf,ulVisibility,fUpdate))
#ifndef SOMGD_xfSetStatusBarVisibility
    #if (defined(_xfSetStatusBarVisibility) || defined(__xfSetStatusBarVisibility))
        #undef _xfSetStatusBarVisibility
        #undef __xfSetStatusBarVisibility
        #define SOMGD_xfSetStatusBarVisibility 1
    #else
        #define _xfSetStatusBarVisibility XFolder_xfSetStatusBarVisibility
    #endif /* _xfSetStatusBarVisibility */
#endif /* SOMGD_xfSetStatusBarVisibility */

/*
 * New Method: xfQueryStatusBarVisibility
 */
typedef BOOL   SOMLINK somTP_XFolder_xfQueryStatusBarVisibility(XFolder *somSelf);
#pragma linkage(somTP_XFolder_xfQueryStatusBarVisibility, system)
typedef somTP_XFolder_xfQueryStatusBarVisibility *somTD_XFolder_xfQueryStatusBarVisibility;
#define somMD_XFolder_xfQueryStatusBarVisibility "::XFolder::xfQueryStatusBarVisibility"
#define XFolder_xfQueryStatusBarVisibility(somSelf) \
    (SOM_Resolve(somSelf, XFolder, xfQueryStatusBarVisibility) \
	(somSelf))
#ifndef SOMGD_xfQueryStatusBarVisibility
    #if (defined(_xfQueryStatusBarVisibility) || defined(__xfQueryStatusBarVisibility))
        #undef _xfQueryStatusBarVisibility
        #undef __xfQueryStatusBarVisibility
        #define SOMGD_xfQueryStatusBarVisibility 1
    #else
        #define _xfQueryStatusBarVisibility XFolder_xfQueryStatusBarVisibility
    #endif /* _xfQueryStatusBarVisibility */
#endif /* SOMGD_xfQueryStatusBarVisibility */

/*
 * New Method: xfForEachOpenView
 */
typedef BOOL   SOMLINK somTP_XFolder_xfForEachOpenView(XFolder *somSelf,
		ULONG ulMsg,
		PFNWP pfnwpCallback);
#pragma linkage(somTP_XFolder_xfForEachOpenView, system)
typedef somTP_XFolder_xfForEachOpenView *somTD_XFolder_xfForEachOpenView;
#define somMD_XFolder_xfForEachOpenView "::XFolder::xfForEachOpenView"
#define XFolder_xfForEachOpenView(somSelf,ulMsg,pfnwpCallback) \
    (SOM_Resolve(somSelf, XFolder, xfForEachOpenView) \
	(somSelf,ulMsg,pfnwpCallback))
#ifndef SOMGD_xfForEachOpenView
    #if (defined(_xfForEachOpenView) || defined(__xfForEachOpenView))
        #undef _xfForEachOpenView
        #undef __xfForEachOpenView
        #define SOMGD_xfForEachOpenView 1
    #else
        #define _xfForEachOpenView XFolder_xfForEachOpenView
    #endif /* _xfForEachOpenView */
#endif /* SOMGD_xfForEachOpenView */

/*
 * New Method: xfAddXFolderPages
 */
typedef ULONG   SOMLINK somTP_XFolder_xfAddXFolderPages(XFolder *somSelf,
		HWND hwndDlg);
#pragma linkage(somTP_XFolder_xfAddXFolderPages, system)
typedef somTP_XFolder_xfAddXFolderPages *somTD_XFolder_xfAddXFolderPages;
#define somMD_XFolder_xfAddXFolderPages "::XFolder::xfAddXFolderPages"
#define XFolder_xfAddXFolderPages(somSelf,hwndDlg) \
    (SOM_Resolve(somSelf, XFolder, xfAddXFolderPages) \
	(somSelf,hwndDlg))
#ifndef SOMGD_xfAddXFolderPages
    #if (defined(_xfAddXFolderPages) || defined(__xfAddXFolderPages))
        #undef _xfAddXFolderPages
        #undef __xfAddXFolderPages
        #define SOMGD_xfAddXFolderPages 1
    #else
        #define _xfAddXFolderPages XFolder_xfAddXFolderPages
    #endif /* _xfAddXFolderPages */
#endif /* SOMGD_xfAddXFolderPages */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define XFolder_wpSetFldrFlags WPFolder_wpSetFldrFlags
#define XFolder_wpQueryFldrFlags WPFolder_wpQueryFldrFlags
#define XFolder_wpSetFldrFont WPFolder_wpSetFldrFont
#define XFolder_wpQueryFldrFont WPFolder_wpQueryFldrFont
#define XFolder_wpSetNextIconPos WPFolder_wpSetNextIconPos
#define XFolder_wpQueryNextIconPos WPFolder_wpQueryNextIconPos
#define XFolder_wpPopulate WPFolder_wpPopulate
#define XFolder_wpQueryContent WPFolder_wpQueryContent
#define XFolder_wpAddFolderView1Page WPFolder_wpAddFolderView1Page
#define XFolder_wpAddFolderView2Page WPFolder_wpAddFolderView2Page
#define XFolder_wpAddFolderView3Page WPFolder_wpAddFolderView3Page
#define XFolder_wpAddFolderIncludePage WPFolder_wpAddFolderIncludePage
#define XFolder_wpAddFolderBackgroundPage WPFolder_wpAddFolderBackgroundPage
#define XFolder_wpAddFolderSelfClosePage WPFolder_wpAddFolderSelfClosePage
#define XFolder_wpInitIconPosData WPFolder_wpInitIconPosData
#define XFolder_wpFreeIconPosData WPFolder_wpFreeIconPosData
#define XFolder_wpQueryIconPosition WPFolder_wpQueryIconPosition
#define XFolder_wpQueryFldrSort WPFolder_wpQueryFldrSort
#define XFolder_wpRestoreFldrRunObjs WPFolder_wpRestoreFldrRunObjs
#define XFolder_wpStoreFldrRunObjs WPFolder_wpStoreFldrRunObjs
#define XFolder_wpHideFldrRunObjs WPFolder_wpHideFldrRunObjs
#define XFolder_wpDeleteContents WPFolder_wpDeleteContents
#define XFolder_wpSetFldrDetailsClass WPFolder_wpSetFldrDetailsClass
#define XFolder_wpQueryFldrDetailsClass WPFolder_wpQueryFldrDetailsClass
#define XFolder_wpSearchFolder WPFolder_wpSearchFolder
#define XFolder_wpContainsFolders WPFolder_wpContainsFolders
#define XFolder_wpQueryOpenFolders WPFolder_wpQueryOpenFolders
#define XFolder_wpModifyFldrFlags WPFolder_wpModifyFldrFlags
#define XFolder_wpSetDetailsColumnVisibility WPFolder_wpSetDetailsColumnVisibility
#define XFolder_wpIsDetailsColumnVisible WPFolder_wpIsDetailsColumnVisible
#define XFolder_wpSetFldrSortClass WPFolder_wpSetFldrSortClass
#define XFolder_wpQueryFldrSortClass WPFolder_wpQueryFldrSortClass
#define XFolder_wpSetSortAttribAvailable WPFolder_wpSetSortAttribAvailable
#define XFolder_wpIsSortAttribAvailable WPFolder_wpIsSortAttribAvailable
#define XFolder_wpQueryIconViewPos WPFolder_wpQueryIconViewPos
#define XFolder_wpAddFirstChild WPFolder_wpAddFirstChild
#define XFolder_wpSetRealName WPFileSystem_wpSetRealName
#define XFolder_wpSetType WPFileSystem_wpSetType
#define XFolder_wpQueryType WPFileSystem_wpQueryType
#define XFolder_wpSetAttr WPFileSystem_wpSetAttr
#define XFolder_wpQueryAttr WPFileSystem_wpQueryAttr
#define XFolder_wpAddFile1Page WPFileSystem_wpAddFile1Page
#define XFolder_wpAddFile2Page WPFileSystem_wpAddFile2Page
#define XFolder_wpAddFile3Page WPFileSystem_wpAddFile3Page
#define XFolder_wpAddFileMenuPage WPFileSystem_wpAddFileMenuPage
#define XFolder_wpQueryCreation WPFileSystem_wpQueryCreation
#define XFolder_wpQueryLastAccess WPFileSystem_wpQueryLastAccess
#define XFolder_wpQueryLastWrite WPFileSystem_wpQueryLastWrite
#define XFolder_wpQueryFileSize WPFileSystem_wpQueryFileSize
#define XFolder_wpQueryEASize WPFileSystem_wpQueryEASize
#define XFolder_wpSetDateInfo WPFileSystem_wpSetDateInfo
#define XFolder_wpSetFileSizeInfo WPFileSystem_wpSetFileSizeInfo
#define XFolder_wpQueryRefreshFlags WPFileSystem_wpQueryRefreshFlags
#define XFolder_wpSetRefreshFlags WPFileSystem_wpSetRefreshFlags
#define XFolder_wpPrintPlainTextFile WPFileSystem_wpPrintPlainTextFile
#define XFolder_wpSetTitleAndRenameFile WPFileSystem_wpSetTitleAndRenameFile
#define XFolder_wpConfirmRenameFileWithExt WPFileSystem_wpConfirmRenameFileWithExt
#define XFolder_wpVerifyUpdateAccess WPFileSystem_wpVerifyUpdateAccess
#define XFolder_wpAddUserItemsToPopupMenu WPFileSystem_wpAddUserItemsToPopupMenu
#define XFolder_wpIsDiskSwapped WPFileSystem_wpIsDiskSwapped
#define XFolder_wpQueryRealName WPFileSystem_wpQueryRealName
#define XFolder_wpQueryFilename WPFileSystem_wpQueryFilename
#define XFolder_wpQueryDisk WPFileSystem_wpQueryDisk
#define XFolder_wpQueryDateInfo WPFileSystem_wpQueryDateInfo
#define XFolder_wpConfirmKeepAssoc WPFileSystem_wpConfirmKeepAssoc
#define XFolder_wpAddObjectGeneralPage WPObject_wpAddObjectGeneralPage
#define XFolder_wpAddObjectGeneralPage2 WPObject_wpAddObjectGeneralPage2
#define XFolder_wpAddObjectWindowPage WPObject_wpAddObjectWindowPage
#define XFolder_wpAddToObjUseList WPObject_wpAddToObjUseList
#define XFolder_wpAllocMem WPObject_wpAllocMem
#define XFolder_wpAppendObject WPObject_wpAppendObject
#define XFolder_wpAssertObjectMutexSem WPObject_wpAssertObjectMutexSem
#define XFolder_wpClose WPObject_wpClose
#define XFolder_wpCnrInsertObject WPObject_wpCnrInsertObject
#define XFolder_wpCnrRemoveObject WPObject_wpCnrRemoveObject
#define XFolder_wpCnrSetEmphasis WPObject_wpCnrSetEmphasis
#define XFolder_wpConfirmDelete WPObject_wpConfirmDelete
#define XFolder_wpConfirmObjectTitle WPObject_wpConfirmObjectTitle
#define XFolder_wpCopiedFromTemplate WPObject_wpCopiedFromTemplate
#define XFolder_wpCopyObject WPObject_wpCopyObject
#define XFolder_wpCreateAnother WPObject_wpCreateAnother
#define XFolder_wpCreateFromTemplate WPObject_wpCreateFromTemplate
#define XFolder_wpCreateShadowObject WPObject_wpCreateShadowObject
#define XFolder_wpDelete WPObject_wpDelete
#define XFolder_wpDeleteFromObjUseList WPObject_wpDeleteFromObjUseList
#define XFolder_wpDisplayHelp WPObject_wpDisplayHelp
#define XFolder_wpDisplayMenu WPObject_wpDisplayMenu
#define XFolder_wpDoesObjectMatch WPObject_wpDoesObjectMatch
#define XFolder_wpDraggedOverObject WPObject_wpDraggedOverObject
#define XFolder_wpDragOver WPObject_wpDragOver
#define XFolder_wpDrop WPObject_wpDrop
#define XFolder_wpDroppedOnObject WPObject_wpDroppedOnObject
#define XFolder_wpEndConversation WPObject_wpEndConversation
#define XFolder_wpFindUseItem WPObject_wpFindUseItem
#define XFolder_wpFormatDragItem WPObject_wpFormatDragItem
#define XFolder_wpFreeMem WPObject_wpFreeMem
#define XFolder_wpHide WPObject_wpHide
#define XFolder_wpInsertPopupMenuItems WPObject_wpInsertPopupMenuItems
#define XFolder_wpInsertSettingsPage WPObject_wpInsertSettingsPage
#define XFolder_wpPrintObject WPObject_wpPrintObject
#define XFolder_wpQueryConcurrentView WPObject_wpQueryConcurrentView
#define XFolder_wpQueryButtonAppearance WPObject_wpQueryButtonAppearance
#define XFolder_wpQueryConfirmations WPObject_wpQueryConfirmations
#define XFolder_wpQueryDefaultView WPObject_wpQueryDefaultView
#define XFolder_wpQueryDetailsData WPObject_wpQueryDetailsData
#define XFolder_wpQueryError WPObject_wpQueryError
#define XFolder_wpSetFolder WPObject_wpSetFolder
#define XFolder_wpQueryFolder WPObject_wpQueryFolder
#define XFolder_wpQueryIcon WPObject_wpQueryIcon
#define XFolder_wpQueryIconData WPObject_wpQueryIconData
#define XFolder_wpQueryMinWindow WPObject_wpQueryMinWindow
#define XFolder_wpQueryNameClashOptions WPObject_wpQueryNameClashOptions
#define XFolder_wpQueryStyle WPObject_wpQueryStyle
#define XFolder_wpSetTaskRec WPObject_wpSetTaskRec
#define XFolder_wpFindTaskRec WPObject_wpFindTaskRec
#define XFolder_wpQueryTitle WPObject_wpQueryTitle
#define XFolder_wpRegisterView WPObject_wpRegisterView
#define XFolder_wpReleaseObjectMutexSem WPObject_wpReleaseObjectMutexSem
#define XFolder_wpRender WPObject_wpRender
#define XFolder_wpRenderComplete WPObject_wpRenderComplete
#define XFolder_wpReplaceObject WPObject_wpReplaceObject
#define XFolder_wpRequestObjectMutexSem WPObject_wpRequestObjectMutexSem
#define XFolder_wpRestore WPObject_wpRestore
#define XFolder_wpRestoreString WPObject_wpRestoreString
#define XFolder_wpSaveData WPObject_wpSaveData
#define XFolder_wpSaveImmediate WPObject_wpSaveImmediate
#define XFolder_wpSaveDeferred WPObject_wpSaveDeferred
#define XFolder_wpSaveLong WPObject_wpSaveLong
#define XFolder_wpSaveString WPObject_wpSaveString
#define XFolder_wpScanSetupString WPObject_wpScanSetupString
#define XFolder_wpSetConcurrentView WPObject_wpSetConcurrentView
#define XFolder_wpSetButtonAppearance WPObject_wpSetButtonAppearance
#define XFolder_wpSetDefaultHelp WPObject_wpSetDefaultHelp
#define XFolder_wpSetDefaultView WPObject_wpSetDefaultView
#define XFolder_wpSetError WPObject_wpSetError
#define XFolder_wpSetIconHandle WPObject_wpSetIconHandle
#define XFolder_wpQueryScreenGroupID WPObject_wpQueryScreenGroupID
#define XFolder_wpSetupOnce WPObject_wpSetupOnce
#define XFolder_wpSetIcon WPObject_wpSetIcon
#define XFolder_wpSetIconData WPObject_wpSetIconData
#define XFolder_wpSetMinWindow WPObject_wpSetMinWindow
#define XFolder_wpSetStyle WPObject_wpSetStyle
#define XFolder_wpModifyStyle WPObject_wpModifyStyle
#define XFolder_wpSwitchTo WPObject_wpSwitchTo
#define XFolder_wpViewObject WPObject_wpViewObject
#define XFolder_wpQueryTrueStyle WPObject_wpQueryTrueStyle
#define XFolder_wpQueryHandle WPObject_wpQueryHandle
#define XFolder_wpUnlockObject WPObject_wpUnlockObject
#define XFolder_wpObjectReady WPObject_wpObjectReady
#define XFolder_wpIsObjectInitialized WPObject_wpIsObjectInitialized
#define XFolder_wpCreateShadowObjectExt WPObject_wpCreateShadowObjectExt
#define XFolder_wpCnrDeleteUseItem WPObject_wpCnrDeleteUseItem
#define XFolder_wpIsDeleteable WPObject_wpIsDeleteable
#define XFolder_wpQueryCoreRecord WPObject_wpQueryCoreRecord
#define XFolder_wpSetObjectID WPObject_wpSetObjectID
#define XFolder_wpQueryObjectID WPObject_wpQueryObjectID
#define XFolder_wpSetDefaultIconPos WPObject_wpSetDefaultIconPos
#define XFolder_wpQueryDefaultIconPos WPObject_wpQueryDefaultIconPos
#define XFolder_wpCnrRefreshDetails WPObject_wpCnrRefreshDetails
#define XFolder_wpFindViewItem WPObject_wpFindViewItem
#define XFolder_wpLockObject WPObject_wpLockObject
#define XFolder_wpIsLocked WPObject_wpIsLocked
#define XFolder_wpQueryContainerFlagPtr WPObject_wpQueryContainerFlagPtr
#define XFolder_wpWaitForClose WPObject_wpWaitForClose
#define XFolder_somDefaultInit SOMObject_somDefaultInit
#define XFolder_somDestruct SOMObject_somDestruct
#define XFolder_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define XFolder_somDefaultAssign SOMObject_somDefaultAssign
#define XFolder_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define XFolder_somDefaultVCopyInit SOMObject_somDefaultVCopyInit
#define XFolder_somDefaultConstVCopyInit SOMObject_somDefaultConstVCopyInit
#define XFolder_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define XFolder_somDefaultVAssign SOMObject_somDefaultVAssign
#define XFolder_somDefaultConstVAssign SOMObject_somDefaultConstVAssign
#define XFolder_somInit SOMObject_somInit
#define XFolder_somFree SOMObject_somFree
#define XFolder_somUninit SOMObject_somUninit
#define XFolder_somGetClass SOMObject_somGetClass
#define XFolder_somGetClassName SOMObject_somGetClassName
#define XFolder_somGetSize SOMObject_somGetSize
#define XFolder_somIsA SOMObject_somIsA
#define XFolder_somIsInstanceOf SOMObject_somIsInstanceOf
#define XFolder_somRespondsTo SOMObject_somRespondsTo
#define XFolder_somDispatch SOMObject_somDispatch
#define XFolder_somClassDispatch SOMObject_somClassDispatch
#define XFolder_somCastObj SOMObject_somCastObj
#define XFolder_somResetObj SOMObject_somResetObj
#define XFolder_somDispatchV SOMObject_somDispatchV
#define XFolder_somDispatchL SOMObject_somDispatchL
#define XFolder_somDispatchA SOMObject_somDispatchA
#define XFolder_somDispatchD SOMObject_somDispatchD
#define XFolder_somPrintSelf SOMObject_somPrintSelf
#define XFolder_somDumpSelf SOMObject_somDumpSelf
#define XFolder_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_XFolder_h */

#ifndef SOM_M_XFolder_h
#define SOM_M_XFolder_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default.
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef M_XFolder
#define M_XFolder SOMObject
#endif
#include <wpfolder.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define M_XFolder_MajorVersion 1
#define M_XFolder_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_XFolderNewClass xfMc
#pragma linkage(xfMc, system)
#define M_XFolderClassData xfMd
#define M_XFolderCClassData xfMx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_XFolder_classObj M_XFolderClassData.classObject
#define _M_XFolder M_XFolder_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK M_XFolderNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(M_XFolderNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_XFolderClassDataStructure {
	SOMAny *classObject;
	somMToken xfclsForEachOpenView;
	somMToken xfclsQueryFavoriteFolder;
	somMToken xfclsQueryQuickOpenFolder;
	somMToken xfclsSetDefaultTitle;
	somMToken xfcls_withdrawn1;
} SOMDLINK M_XFolderClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_XFolderCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} SOMDLINK M_XFolderCClassData;

/*
 * New and Renew macros for M_XFolder
 */
#define M_XFolderNew() \
   (_somNew(_M_XFolder ? _M_XFolder : M_XFolderNewClass(M_XFolder_MajorVersion, M_XFolder_MinorVersion)))
#define M_XFolderRenew(buf) \
   (_somRenew(_M_XFolder ? _M_XFolder : M_XFolderNewClass(M_XFolder_MajorVersion, M_XFolder_MinorVersion), buf))

/*
 * Override method: wpclsInitData
 */
#define M_XFolder_wpclsInitData(somSelf) \
	M_WPObject_wpclsInitData(somSelf)

/*
 * Override method: wpclsCreateDefaultTemplates
 */
#define M_XFolder_wpclsCreateDefaultTemplates(somSelf,Folder) \
	M_WPObject_wpclsCreateDefaultTemplates(somSelf,Folder)

/*
 * Override method: wpclsQueryTitle
 */
#define M_XFolder_wpclsQueryTitle(somSelf) \
	M_WPObject_wpclsQueryTitle(somSelf)

/*
 * Override method: wpclsQueryIconData
 */
#define M_XFolder_wpclsQueryIconData(somSelf,pIconInfo) \
	M_WPObject_wpclsQueryIconData(somSelf,pIconInfo)

/*
 * Override method: wpclsQueryIconDataN
 */
#define M_XFolder_wpclsQueryIconDataN(somSelf,pIconInfo,ulIconIndex) \
	M_WPFolder_wpclsQueryIconDataN(somSelf,pIconInfo,ulIconIndex)

/*
 * New Method: xfclsForEachOpenView
 */
typedef BOOL   SOMLINK somTP_M_XFolder_xfclsForEachOpenView(M_XFolder *somSelf,
		ULONG ulMsg,
		PFNWP pfnwpCallback);
#pragma linkage(somTP_M_XFolder_xfclsForEachOpenView, system)
typedef somTP_M_XFolder_xfclsForEachOpenView *somTD_M_XFolder_xfclsForEachOpenView;
#define somMD_M_XFolder_xfclsForEachOpenView "::M_XFolder::xfclsForEachOpenView"
#define M_XFolder_xfclsForEachOpenView(somSelf,ulMsg,pfnwpCallback) \
    (SOM_Resolve(somSelf, M_XFolder, xfclsForEachOpenView) \
	(somSelf,ulMsg,pfnwpCallback))
#ifndef SOMGD_xfclsForEachOpenView
    #if (defined(_xfclsForEachOpenView) || defined(__xfclsForEachOpenView))
        #undef _xfclsForEachOpenView
        #undef __xfclsForEachOpenView
        #define SOMGD_xfclsForEachOpenView 1
    #else
        #define _xfclsForEachOpenView M_XFolder_xfclsForEachOpenView
    #endif /* _xfclsForEachOpenView */
#endif /* SOMGD_xfclsForEachOpenView */

/*
 * New Method: xfclsQueryFavoriteFolder
 */
typedef XFolder*   SOMLINK somTP_M_XFolder_xfclsQueryFavoriteFolder(M_XFolder *somSelf,
		XFolder* pFolder);
#pragma linkage(somTP_M_XFolder_xfclsQueryFavoriteFolder, system)
typedef somTP_M_XFolder_xfclsQueryFavoriteFolder *somTD_M_XFolder_xfclsQueryFavoriteFolder;
#define somMD_M_XFolder_xfclsQueryFavoriteFolder "::M_XFolder::xfclsQueryFavoriteFolder"
#define M_XFolder_xfclsQueryFavoriteFolder(somSelf,pFolder) \
    (SOM_Resolve(somSelf, M_XFolder, xfclsQueryFavoriteFolder) \
	(somSelf,pFolder))
#ifndef SOMGD_xfclsQueryFavoriteFolder
    #if (defined(_xfclsQueryFavoriteFolder) || defined(__xfclsQueryFavoriteFolder))
        #undef _xfclsQueryFavoriteFolder
        #undef __xfclsQueryFavoriteFolder
        #define SOMGD_xfclsQueryFavoriteFolder 1
    #else
        #define _xfclsQueryFavoriteFolder M_XFolder_xfclsQueryFavoriteFolder
    #endif /* _xfclsQueryFavoriteFolder */
#endif /* SOMGD_xfclsQueryFavoriteFolder */

/*
 * New Method: xfclsQueryQuickOpenFolder
 */
typedef XFolder*   SOMLINK somTP_M_XFolder_xfclsQueryQuickOpenFolder(M_XFolder *somSelf,
		XFolder* pFolder);
#pragma linkage(somTP_M_XFolder_xfclsQueryQuickOpenFolder, system)
typedef somTP_M_XFolder_xfclsQueryQuickOpenFolder *somTD_M_XFolder_xfclsQueryQuickOpenFolder;
#define somMD_M_XFolder_xfclsQueryQuickOpenFolder "::M_XFolder::xfclsQueryQuickOpenFolder"
#define M_XFolder_xfclsQueryQuickOpenFolder(somSelf,pFolder) \
    (SOM_Resolve(somSelf, M_XFolder, xfclsQueryQuickOpenFolder) \
	(somSelf,pFolder))
#ifndef SOMGD_xfclsQueryQuickOpenFolder
    #if (defined(_xfclsQueryQuickOpenFolder) || defined(__xfclsQueryQuickOpenFolder))
        #undef _xfclsQueryQuickOpenFolder
        #undef __xfclsQueryQuickOpenFolder
        #define SOMGD_xfclsQueryQuickOpenFolder 1
    #else
        #define _xfclsQueryQuickOpenFolder M_XFolder_xfclsQueryQuickOpenFolder
    #endif /* _xfclsQueryQuickOpenFolder */
#endif /* SOMGD_xfclsQueryQuickOpenFolder */

/*
 * New Method: xfclsSetDefaultTitle
 */
typedef BOOL   SOMLINK somTP_M_XFolder_xfclsSetDefaultTitle(M_XFolder *somSelf,
		PSZ pszNewTitle);
#pragma linkage(somTP_M_XFolder_xfclsSetDefaultTitle, system)
typedef somTP_M_XFolder_xfclsSetDefaultTitle *somTD_M_XFolder_xfclsSetDefaultTitle;
#define somMD_M_XFolder_xfclsSetDefaultTitle "::M_XFolder::xfclsSetDefaultTitle"
#define M_XFolder_xfclsSetDefaultTitle(somSelf,pszNewTitle) \
    (SOM_Resolve(somSelf, M_XFolder, xfclsSetDefaultTitle) \
	(somSelf,pszNewTitle))
#ifndef SOMGD_xfclsSetDefaultTitle
    #if (defined(_xfclsSetDefaultTitle) || defined(__xfclsSetDefaultTitle))
        #undef _xfclsSetDefaultTitle
        #undef __xfclsSetDefaultTitle
        #define SOMGD_xfclsSetDefaultTitle 1
    #else
        #define _xfclsSetDefaultTitle M_XFolder_xfclsSetDefaultTitle
    #endif /* _xfclsSetDefaultTitle */
#endif /* SOMGD_xfclsSetDefaultTitle */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define M_XFolder_wpclsQueryIconN M_WPFolder_wpclsQueryIconN
#define M_XFolder_wpclsQueryOpenFolders M_WPFolder_wpclsQueryOpenFolders
#define M_XFolder_wpclsQueryAwakeObject M_WPFileSystem_wpclsQueryAwakeObject
#define M_XFolder_wpclsFileSysExists M_WPFileSystem_wpclsFileSysExists
#define M_XFolder_wpclsQueryObjectFromPath M_WPFileSystem_wpclsQueryObjectFromPath
#define M_XFolder_wpclsQueryInstanceType M_WPFileSystem_wpclsQueryInstanceType
#define M_XFolder_wpclsQueryInstanceFilter M_WPFileSystem_wpclsQueryInstanceFilter
#define M_XFolder_wpclsMakeAwake M_WPObject_wpclsMakeAwake
#define M_XFolder_wpclsNew M_WPObject_wpclsNew
#define M_XFolder_wpclsQueryDefaultHelp M_WPObject_wpclsQueryDefaultHelp
#define M_XFolder_wpclsQueryDefaultView M_WPObject_wpclsQueryDefaultView
#define M_XFolder_wpclsQueryDetails M_WPObject_wpclsQueryDetails
#define M_XFolder_wpclsQueryDetailsInfo M_WPObject_wpclsQueryDetailsInfo
#define M_XFolder_wpclsQueryExtendedCriteria M_WPObject_wpclsQueryExtendedCriteria
#define M_XFolder_wpclsQueryFolder M_WPObject_wpclsQueryFolder
#define M_XFolder_wpclsQueryIcon M_WPObject_wpclsQueryIcon
#define M_XFolder_wpclsQuerySearchInfo M_WPObject_wpclsQuerySearchInfo
#define M_XFolder_wpclsQueryStyle M_WPObject_wpclsQueryStyle
#define M_XFolder_wpclsUnInitData M_WPObject_wpclsUnInitData
#define M_XFolder_wpclsFindObjectFirst M_WPObject_wpclsFindObjectFirst
#define M_XFolder_wpclsFindObjectNext M_WPObject_wpclsFindObjectNext
#define M_XFolder_wpclsFindObjectEnd M_WPObject_wpclsFindObjectEnd
#define M_XFolder_wpclsSetError M_WPObject_wpclsSetError
#define M_XFolder_wpclsQueryError M_WPObject_wpclsQueryError
#define M_XFolder_wpclsQuerySettingsPageSize M_WPObject_wpclsQuerySettingsPageSize
#define M_XFolder_wpclsQueryObject M_WPObject_wpclsQueryObject
#define M_XFolder_wpclsQueryButtonAppearance M_WPObject_wpclsQueryButtonAppearance
#define M_XFolder_wpclsDecUsage M_WPObject_wpclsDecUsage
#define M_XFolder_wpclsIncUsage M_WPObject_wpclsIncUsage
#define M_XFolder_wpclsInsertMultipleObjects M_WPObject_wpclsInsertMultipleObjects
#define M_XFolder_wpclsFindOneObject M_WPObject_wpclsFindOneObject
#define M_XFolder_wpclsSetSettingsPageSize M_WPObject_wpclsSetSettingsPageSize
#define M_XFolder_wpclsSetIconData M_WPObject_wpclsSetIconData
#define M_XFolder_wpclsSetIcon M_WPObject_wpclsSetIcon
#define M_XFolder_wpclsObjectFromHandle M_WPObject_wpclsObjectFromHandle
#define M_XFolder_wpclsRemoveObjects M_WPObject_wpclsRemoveObjects
#define M_XFolder__get_somDataAlignment SOMClass__get_somDataAlignment
#define M_XFolder__get_somInstanceDataOffsets SOMClass__get_somInstanceDataOffsets
#define M_XFolder__get_somDirectInitClasses SOMClass__get_somDirectInitClasses
#define M_XFolder__set_somDirectInitClasses SOMClass__set_somDirectInitClasses
#define M_XFolder_somNew SOMClass_somNew
#define M_XFolder_somNewNoInit SOMClass_somNewNoInit
#define M_XFolder_somRenew SOMClass_somRenew
#define M_XFolder_somRenewNoInit SOMClass_somRenewNoInit
#define M_XFolder_somRenewNoZero SOMClass_somRenewNoZero
#define M_XFolder_somRenewNoInitNoZero SOMClass_somRenewNoInitNoZero
#define M_XFolder_somAllocate SOMClass_somAllocate
#define M_XFolder_somDeallocate SOMClass_somDeallocate
#define M_XFolder__get_somClassAllocate SOMClass__get_somClassAllocate
#define M_XFolder__get_somClassDeallocate SOMClass__get_somClassDeallocate
#define M_XFolder_somGetInstanceInitMask SOMClass_somGetInstanceInitMask
#define M_XFolder_somGetInstanceDestructionMask SOMClass_somGetInstanceDestructionMask
#define M_XFolder_somGetInstanceAssignmentMask SOMClass_somGetInstanceAssignmentMask
#define M_XFolder_somInitClass SOMClass_somInitClass
#define M_XFolder_somInitMIClass SOMClass_somInitMIClass
#define M_XFolder_somAddStaticMethod SOMClass_somAddStaticMethod
#define M_XFolder_somAddDynamicMethod SOMClass_somAddDynamicMethod
#define M_XFolder_somOverrideSMethod SOMClass_somOverrideSMethod
#define M_XFolder_somClassReady SOMClass_somClassReady
#define M_XFolder_somGetApplyStub SOMClass_somGetApplyStub
#define M_XFolder_somGetClassData SOMClass_somGetClassData
#define M_XFolder_somSetClassData SOMClass_somSetClassData
#define M_XFolder_somGetClassMtab SOMClass_somGetClassMtab
#define M_XFolder_somGetInstanceOffset SOMClass_somGetInstanceOffset
#define M_XFolder_somGetInstancePartSize SOMClass_somGetInstancePartSize
#define M_XFolder_somGetInstanceSize SOMClass_somGetInstanceSize
#define M_XFolder_somGetInstanceToken SOMClass_somGetInstanceToken
#define M_XFolder_somGetMemberToken SOMClass_somGetMemberToken
#define M_XFolder_somGetMethodData SOMClass_somGetMethodData
#define M_XFolder_somGetRdStub SOMClass_somGetRdStub
#define M_XFolder_somGetMethodDescriptor SOMClass_somGetMethodDescriptor
#define M_XFolder_somGetMethodIndex SOMClass_somGetMethodIndex
#define M_XFolder_somGetMethodToken SOMClass_somGetMethodToken
#define M_XFolder_somGetName SOMClass_somGetName
#define M_XFolder_somGetNthMethodData SOMClass_somGetNthMethodData
#define M_XFolder_somGetNthMethodInfo SOMClass_somGetNthMethodInfo
#define M_XFolder_somGetNumMethods SOMClass_somGetNumMethods
#define M_XFolder_somGetNumStaticMethods SOMClass_somGetNumStaticMethods
#define M_XFolder_somGetParent SOMClass_somGetParent
#define M_XFolder_somGetParents SOMClass_somGetParents
#define M_XFolder_somGetPClsMtab SOMClass_somGetPClsMtab
#define M_XFolder_somGetPClsMtabs SOMClass_somGetPClsMtabs
#define M_XFolder_somGetVersionNumbers SOMClass_somGetVersionNumbers
#define M_XFolder_somSetMethodDescriptor SOMClass_somSetMethodDescriptor
#define M_XFolder_somFindMethod SOMClass_somFindMethod
#define M_XFolder_somFindMethodOk SOMClass_somFindMethodOk
#define M_XFolder_somFindSMethod SOMClass_somFindSMethod
#define M_XFolder_somFindSMethodOk SOMClass_somFindSMethodOk
#define M_XFolder_somLookupMethod SOMClass_somLookupMethod
#define M_XFolder_somCheckVersion SOMClass_somCheckVersion
#define M_XFolder_somDescendedFrom SOMClass_somDescendedFrom
#define M_XFolder_somSupportsMethod SOMClass_somSupportsMethod
#define M_XFolder_somDefinedMethod SOMClass_somDefinedMethod
#define M_XFolder_somOverrideMtab SOMClass_somOverrideMtab
#define M_XFolder_somDefaultInit SOMObject_somDefaultInit
#define M_XFolder_somDestruct SOMObject_somDestruct
#define M_XFolder_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define M_XFolder_somDefaultAssign SOMObject_somDefaultAssign
#define M_XFolder_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define M_XFolder_somDefaultVCopyInit SOMObject_somDefaultVCopyInit
#define M_XFolder_somDefaultConstVCopyInit SOMObject_somDefaultConstVCopyInit
#define M_XFolder_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define M_XFolder_somDefaultVAssign SOMObject_somDefaultVAssign
#define M_XFolder_somDefaultConstVAssign SOMObject_somDefaultConstVAssign
#define M_XFolder_somInit SOMObject_somInit
#define M_XFolder_somFree SOMObject_somFree
#define M_XFolder_somUninit SOMObject_somUninit
#define M_XFolder_somGetClass SOMObject_somGetClass
#define M_XFolder_somGetClassName SOMObject_somGetClassName
#define M_XFolder_somGetSize SOMObject_somGetSize
#define M_XFolder_somIsA SOMObject_somIsA
#define M_XFolder_somIsInstanceOf SOMObject_somIsInstanceOf
#define M_XFolder_somRespondsTo SOMObject_somRespondsTo
#define M_XFolder_somDispatch SOMObject_somDispatch
#define M_XFolder_somClassDispatch SOMObject_somClassDispatch
#define M_XFolder_somCastObj SOMObject_somCastObj
#define M_XFolder_somResetObj SOMObject_somResetObj
#define M_XFolder_somDispatchV SOMObject_somDispatchV
#define M_XFolder_somDispatchL SOMObject_somDispatchL
#define M_XFolder_somDispatchA SOMObject_somDispatchA
#define M_XFolder_somDispatchD SOMObject_somDispatchD
#define M_XFolder_somPrintSelf SOMObject_somPrintSelf
#define M_XFolder_somDumpSelf SOMObject_somDumpSelf
#define M_XFolder_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_M_XFolder_h */

#ifndef SOM_XFldStartup_h
#define SOM_XFldStartup_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default.
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef XFldStartup
#define XFldStartup SOMObject
#endif
#include <xfldr.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define XFldStartup_MajorVersion 1
#define XFldStartup_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define XFldStartupNewClass xfstupc
#pragma linkage(xfstupc, system)
#define XFldStartupClassData xfstupd
#define XFldStartupCClassData xfstupx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */

/*
 * Include the meta class file
 */
#include <xfldr.h>
/*--------------Migration------------*/
#define XFldStartup_classObj XFldStartupClassData.classObject
#define _XFldStartup XFldStartup_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK XFldStartupNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(XFldStartupNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct XFldStartupClassDataStructure {
	SOMAny *classObject;
} SOMDLINK XFldStartupClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct XFldStartupCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} SOMDLINK XFldStartupCClassData;

/*
 * New and Renew macros for XFldStartup
 */
#define XFldStartupNew() \
   (_somNew(_XFldStartup ? _XFldStartup : XFldStartupNewClass(XFldStartup_MajorVersion, XFldStartup_MinorVersion)))
#define XFldStartupRenew(buf) \
   (_somRenew(_XFldStartup ? _XFldStartup : XFldStartupNewClass(XFldStartup_MajorVersion, XFldStartup_MinorVersion), buf))

/*
 * Override method: wpModifyPopupMenu
 */
#define XFldStartup_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition) \
	WPObject_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition)

/*
 * Override method: wpMenuItemSelected
 */
#define XFldStartup_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId) \
	WPObject_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId)

/*
 * Override method: wpMenuItemHelpSelected
 */
#define XFldStartup_wpMenuItemHelpSelected(somSelf,MenuId) \
	WPObject_wpMenuItemHelpSelected(somSelf,MenuId)

/*
 * Override method: wpQueryDefaultHelp
 */
#define XFldStartup_wpQueryDefaultHelp(somSelf,pHelpPanelId,HelpLibrary) \
	WPObject_wpQueryDefaultHelp(somSelf,pHelpPanelId,HelpLibrary)
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define XFldStartup_xfUpdateAllFrameWndTitles XFolder_xfUpdateAllFrameWndTitles
#define XFldStartup_xfSnapToGrid XFolder_xfSnapToGrid
#define XFldStartup_xfQueryFldrSort XFolder_xfQueryFldrSort
#define XFldStartup_xfSetFldrSort XFolder_xfSetFldrSort
#define XFldStartup_xfSetCnrSort XFolder_xfSetCnrSort
#define XFldStartup_xfSortViewOnce XFolder_xfSortViewOnce
#define XFldStartup_xfGetIconPos XFolder_xfGetIconPos
#define XFldStartup_xfInvalidateOrderedContent XFolder_xfInvalidateOrderedContent
#define XFldStartup_xfUpdateOrderedContent XFolder_xfUpdateOrderedContent
#define XFldStartup_xfQueryOrderedContent XFolder_xfQueryOrderedContent
#define XFldStartup_xfBeginProcessOrderedContent XFolder_xfBeginProcessOrderedContent
#define XFldStartup_xfCancelProcessOrderedContent XFolder_xfCancelProcessOrderedContent
#define XFldStartup_xfMakeFavoriteFolder XFolder_xfMakeFavoriteFolder
#define XFldStartup_xfIsFavoriteFolder XFolder_xfIsFavoriteFolder
#define XFldStartup_xfSetQuickOpen XFolder_xfSetQuickOpen
#define XFldStartup_xfQueryQuickOpen XFolder_xfQueryQuickOpen
#define XFldStartup_xfShowStatusBar XFolder_xfShowStatusBar
#define XFldStartup_xfSetStatusBarVisibility XFolder_xfSetStatusBarVisibility
#define XFldStartup_xfQueryStatusBarVisibility XFolder_xfQueryStatusBarVisibility
#define XFldStartup_xfForEachOpenView XFolder_xfForEachOpenView
#define XFldStartup_xfAddXFolderPages XFolder_xfAddXFolderPages
#define XFldStartup_wpSetFldrFlags WPFolder_wpSetFldrFlags
#define XFldStartup_wpQueryFldrFlags WPFolder_wpQueryFldrFlags
#define XFldStartup_wpSetFldrFont WPFolder_wpSetFldrFont
#define XFldStartup_wpQueryFldrFont WPFolder_wpQueryFldrFont
#define XFldStartup_wpSetFldrAttr WPFolder_wpSetFldrAttr
#define XFldStartup_wpQueryFldrAttr WPFolder_wpQueryFldrAttr
#define XFldStartup_wpSetNextIconPos WPFolder_wpSetNextIconPos
#define XFldStartup_wpQueryNextIconPos WPFolder_wpQueryNextIconPos
#define XFldStartup_wpPopulate WPFolder_wpPopulate
#define XFldStartup_wpQueryContent WPFolder_wpQueryContent
#define XFldStartup_wpAddFolderView1Page WPFolder_wpAddFolderView1Page
#define XFldStartup_wpAddFolderView2Page WPFolder_wpAddFolderView2Page
#define XFldStartup_wpAddFolderView3Page WPFolder_wpAddFolderView3Page
#define XFldStartup_wpAddFolderIncludePage WPFolder_wpAddFolderIncludePage
#define XFldStartup_wpAddFolderSortPage WPFolder_wpAddFolderSortPage
#define XFldStartup_wpAddFolderBackgroundPage WPFolder_wpAddFolderBackgroundPage
#define XFldStartup_wpAddFolderSelfClosePage WPFolder_wpAddFolderSelfClosePage
#define XFldStartup_wpInitIconPosData WPFolder_wpInitIconPosData
#define XFldStartup_wpFreeIconPosData WPFolder_wpFreeIconPosData
#define XFldStartup_wpStoreIconPosData WPFolder_wpStoreIconPosData
#define XFldStartup_wpQueryIconPosition WPFolder_wpQueryIconPosition
#define XFldStartup_wpSetFldrSort WPFolder_wpSetFldrSort
#define XFldStartup_wpQueryFldrSort WPFolder_wpQueryFldrSort
#define XFldStartup_wpRestoreFldrRunObjs WPFolder_wpRestoreFldrRunObjs
#define XFldStartup_wpStoreFldrRunObjs WPFolder_wpStoreFldrRunObjs
#define XFldStartup_wpHideFldrRunObjs WPFolder_wpHideFldrRunObjs
#define XFldStartup_wpDeleteContents WPFolder_wpDeleteContents
#define XFldStartup_wpSetFldrDetailsClass WPFolder_wpSetFldrDetailsClass
#define XFldStartup_wpQueryFldrDetailsClass WPFolder_wpQueryFldrDetailsClass
#define XFldStartup_wpSearchFolder WPFolder_wpSearchFolder
#define XFldStartup_wpContainsFolders WPFolder_wpContainsFolders
#define XFldStartup_wpQueryOpenFolders WPFolder_wpQueryOpenFolders
#define XFldStartup_wpModifyFldrFlags WPFolder_wpModifyFldrFlags
#define XFldStartup_wpAddToContent WPFolder_wpAddToContent
#define XFldStartup_wpDeleteFromContent WPFolder_wpDeleteFromContent
#define XFldStartup_wpSetDetailsColumnVisibility WPFolder_wpSetDetailsColumnVisibility
#define XFldStartup_wpIsDetailsColumnVisible WPFolder_wpIsDetailsColumnVisible
#define XFldStartup_wpSetFldrSortClass WPFolder_wpSetFldrSortClass
#define XFldStartup_wpQueryFldrSortClass WPFolder_wpQueryFldrSortClass
#define XFldStartup_wpSetSortAttribAvailable WPFolder_wpSetSortAttribAvailable
#define XFldStartup_wpIsSortAttribAvailable WPFolder_wpIsSortAttribAvailable
#define XFldStartup_wpQueryIconViewPos WPFolder_wpQueryIconViewPos
#define XFldStartup_wpAddFirstChild WPFolder_wpAddFirstChild
#define XFldStartup_wpSetRealName WPFileSystem_wpSetRealName
#define XFldStartup_wpSetType WPFileSystem_wpSetType
#define XFldStartup_wpQueryType WPFileSystem_wpQueryType
#define XFldStartup_wpSetAttr WPFileSystem_wpSetAttr
#define XFldStartup_wpQueryAttr WPFileSystem_wpQueryAttr
#define XFldStartup_wpAddFile1Page WPFileSystem_wpAddFile1Page
#define XFldStartup_wpAddFile2Page WPFileSystem_wpAddFile2Page
#define XFldStartup_wpAddFile3Page WPFileSystem_wpAddFile3Page
#define XFldStartup_wpAddFileMenuPage WPFileSystem_wpAddFileMenuPage
#define XFldStartup_wpQueryCreation WPFileSystem_wpQueryCreation
#define XFldStartup_wpQueryLastAccess WPFileSystem_wpQueryLastAccess
#define XFldStartup_wpQueryLastWrite WPFileSystem_wpQueryLastWrite
#define XFldStartup_wpQueryFileSize WPFileSystem_wpQueryFileSize
#define XFldStartup_wpQueryEASize WPFileSystem_wpQueryEASize
#define XFldStartup_wpSetDateInfo WPFileSystem_wpSetDateInfo
#define XFldStartup_wpSetFileSizeInfo WPFileSystem_wpSetFileSizeInfo
#define XFldStartup_wpRefresh WPFileSystem_wpRefresh
#define XFldStartup_wpQueryRefreshFlags WPFileSystem_wpQueryRefreshFlags
#define XFldStartup_wpSetRefreshFlags WPFileSystem_wpSetRefreshFlags
#define XFldStartup_wpPrintPlainTextFile WPFileSystem_wpPrintPlainTextFile
#define XFldStartup_wpSetTitleAndRenameFile WPFileSystem_wpSetTitleAndRenameFile
#define XFldStartup_wpConfirmRenameFileWithExt WPFileSystem_wpConfirmRenameFileWithExt
#define XFldStartup_wpVerifyUpdateAccess WPFileSystem_wpVerifyUpdateAccess
#define XFldStartup_wpAddUserItemsToPopupMenu WPFileSystem_wpAddUserItemsToPopupMenu
#define XFldStartup_wpIsDiskSwapped WPFileSystem_wpIsDiskSwapped
#define XFldStartup_wpQueryRealName WPFileSystem_wpQueryRealName
#define XFldStartup_wpQueryFilename WPFileSystem_wpQueryFilename
#define XFldStartup_wpQueryDisk WPFileSystem_wpQueryDisk
#define XFldStartup_wpQueryDateInfo WPFileSystem_wpQueryDateInfo
#define XFldStartup_wpConfirmKeepAssoc WPFileSystem_wpConfirmKeepAssoc
#define XFldStartup_wpAddObjectGeneralPage WPObject_wpAddObjectGeneralPage
#define XFldStartup_wpAddObjectGeneralPage2 WPObject_wpAddObjectGeneralPage2
#define XFldStartup_wpAddObjectWindowPage WPObject_wpAddObjectWindowPage
#define XFldStartup_wpAddSettingsPages WPObject_wpAddSettingsPages
#define XFldStartup_wpAddToObjUseList WPObject_wpAddToObjUseList
#define XFldStartup_wpAllocMem WPObject_wpAllocMem
#define XFldStartup_wpAppendObject WPObject_wpAppendObject
#define XFldStartup_wpAssertObjectMutexSem WPObject_wpAssertObjectMutexSem
#define XFldStartup_wpClose WPObject_wpClose
#define XFldStartup_wpCnrInsertObject WPObject_wpCnrInsertObject
#define XFldStartup_wpCnrRemoveObject WPObject_wpCnrRemoveObject
#define XFldStartup_wpCnrSetEmphasis WPObject_wpCnrSetEmphasis
#define XFldStartup_wpConfirmDelete WPObject_wpConfirmDelete
#define XFldStartup_wpConfirmObjectTitle WPObject_wpConfirmObjectTitle
#define XFldStartup_wpCopiedFromTemplate WPObject_wpCopiedFromTemplate
#define XFldStartup_wpCopyObject WPObject_wpCopyObject
#define XFldStartup_wpCreateAnother WPObject_wpCreateAnother
#define XFldStartup_wpCreateFromTemplate WPObject_wpCreateFromTemplate
#define XFldStartup_wpCreateShadowObject WPObject_wpCreateShadowObject
#define XFldStartup_wpDelete WPObject_wpDelete
#define XFldStartup_wpDeleteFromObjUseList WPObject_wpDeleteFromObjUseList
#define XFldStartup_wpDisplayHelp WPObject_wpDisplayHelp
#define XFldStartup_wpDisplayMenu WPObject_wpDisplayMenu
#define XFldStartup_wpDoesObjectMatch WPObject_wpDoesObjectMatch
#define XFldStartup_wpDraggedOverObject WPObject_wpDraggedOverObject
#define XFldStartup_wpDragOver WPObject_wpDragOver
#define XFldStartup_wpDrop WPObject_wpDrop
#define XFldStartup_wpDroppedOnObject WPObject_wpDroppedOnObject
#define XFldStartup_wpEndConversation WPObject_wpEndConversation
#define XFldStartup_wpFilterPopupMenu WPObject_wpFilterPopupMenu
#define XFldStartup_wpFindUseItem WPObject_wpFindUseItem
#define XFldStartup_wpFormatDragItem WPObject_wpFormatDragItem
#define XFldStartup_wpFree WPObject_wpFree
#define XFldStartup_wpFreeMem WPObject_wpFreeMem
#define XFldStartup_wpHide WPObject_wpHide
#define XFldStartup_wpInitData WPObject_wpInitData
#define XFldStartup_wpInsertPopupMenuItems WPObject_wpInsertPopupMenuItems
#define XFldStartup_wpInsertSettingsPage WPObject_wpInsertSettingsPage
#define XFldStartup_wpMoveObject WPObject_wpMoveObject
#define XFldStartup_wpOpen WPObject_wpOpen
#define XFldStartup_wpPrintObject WPObject_wpPrintObject
#define XFldStartup_wpQueryConcurrentView WPObject_wpQueryConcurrentView
#define XFldStartup_wpQueryButtonAppearance WPObject_wpQueryButtonAppearance
#define XFldStartup_wpQueryConfirmations WPObject_wpQueryConfirmations
#define XFldStartup_wpQueryDefaultView WPObject_wpQueryDefaultView
#define XFldStartup_wpQueryDetailsData WPObject_wpQueryDetailsData
#define XFldStartup_wpQueryError WPObject_wpQueryError
#define XFldStartup_wpSetFolder WPObject_wpSetFolder
#define XFldStartup_wpQueryFolder WPObject_wpQueryFolder
#define XFldStartup_wpQueryIcon WPObject_wpQueryIcon
#define XFldStartup_wpQueryIconData WPObject_wpQueryIconData
#define XFldStartup_wpQueryMinWindow WPObject_wpQueryMinWindow
#define XFldStartup_wpQueryNameClashOptions WPObject_wpQueryNameClashOptions
#define XFldStartup_wpQueryStyle WPObject_wpQueryStyle
#define XFldStartup_wpSetTaskRec WPObject_wpSetTaskRec
#define XFldStartup_wpFindTaskRec WPObject_wpFindTaskRec
#define XFldStartup_wpQueryTitle WPObject_wpQueryTitle
#define XFldStartup_wpRegisterView WPObject_wpRegisterView
#define XFldStartup_wpReleaseObjectMutexSem WPObject_wpReleaseObjectMutexSem
#define XFldStartup_wpRender WPObject_wpRender
#define XFldStartup_wpRenderComplete WPObject_wpRenderComplete
#define XFldStartup_wpReplaceObject WPObject_wpReplaceObject
#define XFldStartup_wpRequestObjectMutexSem WPObject_wpRequestObjectMutexSem
#define XFldStartup_wpRestore WPObject_wpRestore
#define XFldStartup_wpRestoreData WPObject_wpRestoreData
#define XFldStartup_wpRestoreLong WPObject_wpRestoreLong
#define XFldStartup_wpRestoreState WPObject_wpRestoreState
#define XFldStartup_wpRestoreString WPObject_wpRestoreString
#define XFldStartup_wpSaveData WPObject_wpSaveData
#define XFldStartup_wpSaveImmediate WPObject_wpSaveImmediate
#define XFldStartup_wpSaveDeferred WPObject_wpSaveDeferred
#define XFldStartup_wpSaveLong WPObject_wpSaveLong
#define XFldStartup_wpSaveState WPObject_wpSaveState
#define XFldStartup_wpSaveString WPObject_wpSaveString
#define XFldStartup_wpScanSetupString WPObject_wpScanSetupString
#define XFldStartup_wpSetConcurrentView WPObject_wpSetConcurrentView
#define XFldStartup_wpSetButtonAppearance WPObject_wpSetButtonAppearance
#define XFldStartup_wpSetDefaultHelp WPObject_wpSetDefaultHelp
#define XFldStartup_wpSetDefaultView WPObject_wpSetDefaultView
#define XFldStartup_wpSetError WPObject_wpSetError
#define XFldStartup_wpSetIconHandle WPObject_wpSetIconHandle
#define XFldStartup_wpQueryScreenGroupID WPObject_wpQueryScreenGroupID
#define XFldStartup_wpSetupOnce WPObject_wpSetupOnce
#define XFldStartup_wpSetIcon WPObject_wpSetIcon
#define XFldStartup_wpSetIconData WPObject_wpSetIconData
#define XFldStartup_wpSetMinWindow WPObject_wpSetMinWindow
#define XFldStartup_wpSetStyle WPObject_wpSetStyle
#define XFldStartup_wpModifyStyle WPObject_wpModifyStyle
#define XFldStartup_wpSetTitle WPObject_wpSetTitle
#define XFldStartup_wpSetup WPObject_wpSetup
#define XFldStartup_wpSwitchTo WPObject_wpSwitchTo
#define XFldStartup_wpUnInitData WPObject_wpUnInitData
#define XFldStartup_wpViewObject WPObject_wpViewObject
#define XFldStartup_wpQueryTrueStyle WPObject_wpQueryTrueStyle
#define XFldStartup_wpQueryHandle WPObject_wpQueryHandle
#define XFldStartup_wpUnlockObject WPObject_wpUnlockObject
#define XFldStartup_wpObjectReady WPObject_wpObjectReady
#define XFldStartup_wpIsObjectInitialized WPObject_wpIsObjectInitialized
#define XFldStartup_wpCreateShadowObjectExt WPObject_wpCreateShadowObjectExt
#define XFldStartup_wpCnrDeleteUseItem WPObject_wpCnrDeleteUseItem
#define XFldStartup_wpIsDeleteable WPObject_wpIsDeleteable
#define XFldStartup_wpQueryCoreRecord WPObject_wpQueryCoreRecord
#define XFldStartup_wpSetObjectID WPObject_wpSetObjectID
#define XFldStartup_wpQueryObjectID WPObject_wpQueryObjectID
#define XFldStartup_wpSetDefaultIconPos WPObject_wpSetDefaultIconPos
#define XFldStartup_wpQueryDefaultIconPos WPObject_wpQueryDefaultIconPos
#define XFldStartup_wpCnrRefreshDetails WPObject_wpCnrRefreshDetails
#define XFldStartup_wpFindViewItem WPObject_wpFindViewItem
#define XFldStartup_wpLockObject WPObject_wpLockObject
#define XFldStartup_wpIsLocked WPObject_wpIsLocked
#define XFldStartup_wpQueryContainerFlagPtr WPObject_wpQueryContainerFlagPtr
#define XFldStartup_wpWaitForClose WPObject_wpWaitForClose
#define XFldStartup_somDefaultInit SOMObject_somDefaultInit
#define XFldStartup_somDestruct SOMObject_somDestruct
#define XFldStartup_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define XFldStartup_somDefaultAssign SOMObject_somDefaultAssign
#define XFldStartup_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define XFldStartup_somDefaultVCopyInit SOMObject_somDefaultVCopyInit
#define XFldStartup_somDefaultConstVCopyInit SOMObject_somDefaultConstVCopyInit
#define XFldStartup_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define XFldStartup_somDefaultVAssign SOMObject_somDefaultVAssign
#define XFldStartup_somDefaultConstVAssign SOMObject_somDefaultConstVAssign
#define XFldStartup_somInit SOMObject_somInit
#define XFldStartup_somFree SOMObject_somFree
#define XFldStartup_somUninit SOMObject_somUninit
#define XFldStartup_somGetClass SOMObject_somGetClass
#define XFldStartup_somGetClassName SOMObject_somGetClassName
#define XFldStartup_somGetSize SOMObject_somGetSize
#define XFldStartup_somIsA SOMObject_somIsA
#define XFldStartup_somIsInstanceOf SOMObject_somIsInstanceOf
#define XFldStartup_somRespondsTo SOMObject_somRespondsTo
#define XFldStartup_somDispatch SOMObject_somDispatch
#define XFldStartup_somClassDispatch SOMObject_somClassDispatch
#define XFldStartup_somCastObj SOMObject_somCastObj
#define XFldStartup_somResetObj SOMObject_somResetObj
#define XFldStartup_somDispatchV SOMObject_somDispatchV
#define XFldStartup_somDispatchL SOMObject_somDispatchL
#define XFldStartup_somDispatchA SOMObject_somDispatchA
#define XFldStartup_somDispatchD SOMObject_somDispatchD
#define XFldStartup_somPrintSelf SOMObject_somPrintSelf
#define XFldStartup_somDumpSelf SOMObject_somDumpSelf
#define XFldStartup_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_XFldStartup_h */

#ifndef SOM_M_XFldStartup_h
#define SOM_M_XFldStartup_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default.
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef M_XFldStartup
#define M_XFldStartup SOMObject
#endif
#include <xfldr.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define M_XFldStartup_MajorVersion 1
#define M_XFldStartup_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_XFldStartupNewClass xfstupMc
#pragma linkage(xfstupMc, system)
#define M_XFldStartupClassData xfstupMd
#define M_XFldStartupCClassData xfstupMx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_XFldStartup_classObj M_XFldStartupClassData.classObject
#define _M_XFldStartup M_XFldStartup_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK M_XFldStartupNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(M_XFldStartupNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_XFldStartupClassDataStructure {
	SOMAny *classObject;
} SOMDLINK M_XFldStartupClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_XFldStartupCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} SOMDLINK M_XFldStartupCClassData;

/*
 * New and Renew macros for M_XFldStartup
 */
#define M_XFldStartupNew() \
   (_somNew(_M_XFldStartup ? _M_XFldStartup : M_XFldStartupNewClass(M_XFldStartup_MajorVersion, M_XFldStartup_MinorVersion)))
#define M_XFldStartupRenew(buf) \
   (_somRenew(_M_XFldStartup ? _M_XFldStartup : M_XFldStartupNewClass(M_XFldStartup_MajorVersion, M_XFldStartup_MinorVersion), buf))

/*
 * Override method: wpclsQueryTitle
 */
#define M_XFldStartup_wpclsQueryTitle(somSelf) \
	M_WPObject_wpclsQueryTitle(somSelf)

/*
 * Override method: wpclsQueryStyle
 */
#define M_XFldStartup_wpclsQueryStyle(somSelf) \
	M_WPObject_wpclsQueryStyle(somSelf)

/*
 * Override method: wpclsQueryIconData
 */
#define M_XFldStartup_wpclsQueryIconData(somSelf,pIconInfo) \
	M_WPObject_wpclsQueryIconData(somSelf,pIconInfo)

/*
 * Override method: wpclsQueryIconDataN
 */
#define M_XFldStartup_wpclsQueryIconDataN(somSelf,pIconInfo,ulIconIndex) \
	M_WPFolder_wpclsQueryIconDataN(somSelf,pIconInfo,ulIconIndex)
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define M_XFldStartup_xfclsForEachOpenView M_XFolder_xfclsForEachOpenView
#define M_XFldStartup_xfclsQueryFavoriteFolder M_XFolder_xfclsQueryFavoriteFolder
#define M_XFldStartup_xfclsQueryQuickOpenFolder M_XFolder_xfclsQueryQuickOpenFolder
#define M_XFldStartup_xfclsSetDefaultTitle M_XFolder_xfclsSetDefaultTitle
#define M_XFldStartup_wpclsQueryIconN M_WPFolder_wpclsQueryIconN
#define M_XFldStartup_wpclsQueryOpenFolders M_WPFolder_wpclsQueryOpenFolders
#define M_XFldStartup_wpclsQueryAwakeObject M_WPFileSystem_wpclsQueryAwakeObject
#define M_XFldStartup_wpclsFileSysExists M_WPFileSystem_wpclsFileSysExists
#define M_XFldStartup_wpclsQueryObjectFromPath M_WPFileSystem_wpclsQueryObjectFromPath
#define M_XFldStartup_wpclsQueryInstanceType M_WPFileSystem_wpclsQueryInstanceType
#define M_XFldStartup_wpclsQueryInstanceFilter M_WPFileSystem_wpclsQueryInstanceFilter
#define M_XFldStartup_wpclsCreateDefaultTemplates M_WPObject_wpclsCreateDefaultTemplates
#define M_XFldStartup_wpclsInitData M_WPObject_wpclsInitData
#define M_XFldStartup_wpclsMakeAwake M_WPObject_wpclsMakeAwake
#define M_XFldStartup_wpclsNew M_WPObject_wpclsNew
#define M_XFldStartup_wpclsQueryDefaultHelp M_WPObject_wpclsQueryDefaultHelp
#define M_XFldStartup_wpclsQueryDefaultView M_WPObject_wpclsQueryDefaultView
#define M_XFldStartup_wpclsQueryDetails M_WPObject_wpclsQueryDetails
#define M_XFldStartup_wpclsQueryDetailsInfo M_WPObject_wpclsQueryDetailsInfo
#define M_XFldStartup_wpclsQueryExtendedCriteria M_WPObject_wpclsQueryExtendedCriteria
#define M_XFldStartup_wpclsQueryFolder M_WPObject_wpclsQueryFolder
#define M_XFldStartup_wpclsQueryIcon M_WPObject_wpclsQueryIcon
#define M_XFldStartup_wpclsQuerySearchInfo M_WPObject_wpclsQuerySearchInfo
#define M_XFldStartup_wpclsUnInitData M_WPObject_wpclsUnInitData
#define M_XFldStartup_wpclsFindObjectFirst M_WPObject_wpclsFindObjectFirst
#define M_XFldStartup_wpclsFindObjectNext M_WPObject_wpclsFindObjectNext
#define M_XFldStartup_wpclsFindObjectEnd M_WPObject_wpclsFindObjectEnd
#define M_XFldStartup_wpclsSetError M_WPObject_wpclsSetError
#define M_XFldStartup_wpclsQueryError M_WPObject_wpclsQueryError
#define M_XFldStartup_wpclsQuerySettingsPageSize M_WPObject_wpclsQuerySettingsPageSize
#define M_XFldStartup_wpclsQueryObject M_WPObject_wpclsQueryObject
#define M_XFldStartup_wpclsQueryButtonAppearance M_WPObject_wpclsQueryButtonAppearance
#define M_XFldStartup_wpclsDecUsage M_WPObject_wpclsDecUsage
#define M_XFldStartup_wpclsIncUsage M_WPObject_wpclsIncUsage
#define M_XFldStartup_wpclsInsertMultipleObjects M_WPObject_wpclsInsertMultipleObjects
#define M_XFldStartup_wpclsFindOneObject M_WPObject_wpclsFindOneObject
#define M_XFldStartup_wpclsSetSettingsPageSize M_WPObject_wpclsSetSettingsPageSize
#define M_XFldStartup_wpclsSetIconData M_WPObject_wpclsSetIconData
#define M_XFldStartup_wpclsSetIcon M_WPObject_wpclsSetIcon
#define M_XFldStartup_wpclsObjectFromHandle M_WPObject_wpclsObjectFromHandle
#define M_XFldStartup_wpclsRemoveObjects M_WPObject_wpclsRemoveObjects
#define M_XFldStartup__get_somDataAlignment SOMClass__get_somDataAlignment
#define M_XFldStartup__get_somInstanceDataOffsets SOMClass__get_somInstanceDataOffsets
#define M_XFldStartup__get_somDirectInitClasses SOMClass__get_somDirectInitClasses
#define M_XFldStartup__set_somDirectInitClasses SOMClass__set_somDirectInitClasses
#define M_XFldStartup_somNew SOMClass_somNew
#define M_XFldStartup_somNewNoInit SOMClass_somNewNoInit
#define M_XFldStartup_somRenew SOMClass_somRenew
#define M_XFldStartup_somRenewNoInit SOMClass_somRenewNoInit
#define M_XFldStartup_somRenewNoZero SOMClass_somRenewNoZero
#define M_XFldStartup_somRenewNoInitNoZero SOMClass_somRenewNoInitNoZero
#define M_XFldStartup_somAllocate SOMClass_somAllocate
#define M_XFldStartup_somDeallocate SOMClass_somDeallocate
#define M_XFldStartup__get_somClassAllocate SOMClass__get_somClassAllocate
#define M_XFldStartup__get_somClassDeallocate SOMClass__get_somClassDeallocate
#define M_XFldStartup_somGetInstanceInitMask SOMClass_somGetInstanceInitMask
#define M_XFldStartup_somGetInstanceDestructionMask SOMClass_somGetInstanceDestructionMask
#define M_XFldStartup_somGetInstanceAssignmentMask SOMClass_somGetInstanceAssignmentMask
#define M_XFldStartup_somInitClass SOMClass_somInitClass
#define M_XFldStartup_somInitMIClass SOMClass_somInitMIClass
#define M_XFldStartup_somAddStaticMethod SOMClass_somAddStaticMethod
#define M_XFldStartup_somAddDynamicMethod SOMClass_somAddDynamicMethod
#define M_XFldStartup_somOverrideSMethod SOMClass_somOverrideSMethod
#define M_XFldStartup_somClassReady SOMClass_somClassReady
#define M_XFldStartup_somGetApplyStub SOMClass_somGetApplyStub
#define M_XFldStartup_somGetClassData SOMClass_somGetClassData
#define M_XFldStartup_somSetClassData SOMClass_somSetClassData
#define M_XFldStartup_somGetClassMtab SOMClass_somGetClassMtab
#define M_XFldStartup_somGetInstanceOffset SOMClass_somGetInstanceOffset
#define M_XFldStartup_somGetInstancePartSize SOMClass_somGetInstancePartSize
#define M_XFldStartup_somGetInstanceSize SOMClass_somGetInstanceSize
#define M_XFldStartup_somGetInstanceToken SOMClass_somGetInstanceToken
#define M_XFldStartup_somGetMemberToken SOMClass_somGetMemberToken
#define M_XFldStartup_somGetMethodData SOMClass_somGetMethodData
#define M_XFldStartup_somGetRdStub SOMClass_somGetRdStub
#define M_XFldStartup_somGetMethodDescriptor SOMClass_somGetMethodDescriptor
#define M_XFldStartup_somGetMethodIndex SOMClass_somGetMethodIndex
#define M_XFldStartup_somGetMethodToken SOMClass_somGetMethodToken
#define M_XFldStartup_somGetName SOMClass_somGetName
#define M_XFldStartup_somGetNthMethodData SOMClass_somGetNthMethodData
#define M_XFldStartup_somGetNthMethodInfo SOMClass_somGetNthMethodInfo
#define M_XFldStartup_somGetNumMethods SOMClass_somGetNumMethods
#define M_XFldStartup_somGetNumStaticMethods SOMClass_somGetNumStaticMethods
#define M_XFldStartup_somGetParent SOMClass_somGetParent
#define M_XFldStartup_somGetParents SOMClass_somGetParents
#define M_XFldStartup_somGetPClsMtab SOMClass_somGetPClsMtab
#define M_XFldStartup_somGetPClsMtabs SOMClass_somGetPClsMtabs
#define M_XFldStartup_somGetVersionNumbers SOMClass_somGetVersionNumbers
#define M_XFldStartup_somSetMethodDescriptor SOMClass_somSetMethodDescriptor
#define M_XFldStartup_somFindMethod SOMClass_somFindMethod
#define M_XFldStartup_somFindMethodOk SOMClass_somFindMethodOk
#define M_XFldStartup_somFindSMethod SOMClass_somFindSMethod
#define M_XFldStartup_somFindSMethodOk SOMClass_somFindSMethodOk
#define M_XFldStartup_somLookupMethod SOMClass_somLookupMethod
#define M_XFldStartup_somCheckVersion SOMClass_somCheckVersion
#define M_XFldStartup_somDescendedFrom SOMClass_somDescendedFrom
#define M_XFldStartup_somSupportsMethod SOMClass_somSupportsMethod
#define M_XFldStartup_somDefinedMethod SOMClass_somDefinedMethod
#define M_XFldStartup_somOverrideMtab SOMClass_somOverrideMtab
#define M_XFldStartup_somDefaultInit SOMObject_somDefaultInit
#define M_XFldStartup_somDestruct SOMObject_somDestruct
#define M_XFldStartup_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define M_XFldStartup_somDefaultAssign SOMObject_somDefaultAssign
#define M_XFldStartup_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define M_XFldStartup_somDefaultVCopyInit SOMObject_somDefaultVCopyInit
#define M_XFldStartup_somDefaultConstVCopyInit SOMObject_somDefaultConstVCopyInit
#define M_XFldStartup_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define M_XFldStartup_somDefaultVAssign SOMObject_somDefaultVAssign
#define M_XFldStartup_somDefaultConstVAssign SOMObject_somDefaultConstVAssign
#define M_XFldStartup_somInit SOMObject_somInit
#define M_XFldStartup_somFree SOMObject_somFree
#define M_XFldStartup_somUninit SOMObject_somUninit
#define M_XFldStartup_somGetClass SOMObject_somGetClass
#define M_XFldStartup_somGetClassName SOMObject_somGetClassName
#define M_XFldStartup_somGetSize SOMObject_somGetSize
#define M_XFldStartup_somIsA SOMObject_somIsA
#define M_XFldStartup_somIsInstanceOf SOMObject_somIsInstanceOf
#define M_XFldStartup_somRespondsTo SOMObject_somRespondsTo
#define M_XFldStartup_somDispatch SOMObject_somDispatch
#define M_XFldStartup_somClassDispatch SOMObject_somClassDispatch
#define M_XFldStartup_somCastObj SOMObject_somCastObj
#define M_XFldStartup_somResetObj SOMObject_somResetObj
#define M_XFldStartup_somDispatchV SOMObject_somDispatchV
#define M_XFldStartup_somDispatchL SOMObject_somDispatchL
#define M_XFldStartup_somDispatchA SOMObject_somDispatchA
#define M_XFldStartup_somDispatchD SOMObject_somDispatchD
#define M_XFldStartup_somPrintSelf SOMObject_somPrintSelf
#define M_XFldStartup_somDumpSelf SOMObject_somDumpSelf
#define M_XFldStartup_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_M_XFldStartup_h */

#ifndef SOM_XFldShutdown_h
#define SOM_XFldShutdown_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default.
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef XFldShutdown
#define XFldShutdown SOMObject
#endif
#include <xfldr.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define XFldShutdown_MajorVersion 1
#define XFldShutdown_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define XFldShutdownNewClass xfshutc
#pragma linkage(xfshutc, system)
#define XFldShutdownClassData xfshutd
#define XFldShutdownCClassData xfshutx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */

/*
 * Include the meta class file
 */
#include <xfldr.h>
/*--------------Migration------------*/
#define XFldShutdown_classObj XFldShutdownClassData.classObject
#define _XFldShutdown XFldShutdown_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK XFldShutdownNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(XFldShutdownNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct XFldShutdownClassDataStructure {
	SOMAny *classObject;
} SOMDLINK XFldShutdownClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct XFldShutdownCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} SOMDLINK XFldShutdownCClassData;

/*
 * New and Renew macros for XFldShutdown
 */
#define XFldShutdownNew() \
   (_somNew(_XFldShutdown ? _XFldShutdown : XFldShutdownNewClass(XFldShutdown_MajorVersion, XFldShutdown_MinorVersion)))
#define XFldShutdownRenew(buf) \
   (_somRenew(_XFldShutdown ? _XFldShutdown : XFldShutdownNewClass(XFldShutdown_MajorVersion, XFldShutdown_MinorVersion), buf))

/*
 * Override method: wpQueryDefaultHelp
 */
#define XFldShutdown_wpQueryDefaultHelp(somSelf,pHelpPanelId,HelpLibrary) \
	WPObject_wpQueryDefaultHelp(somSelf,pHelpPanelId,HelpLibrary)
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define XFldShutdown_xfUpdateAllFrameWndTitles XFolder_xfUpdateAllFrameWndTitles
#define XFldShutdown_xfSnapToGrid XFolder_xfSnapToGrid
#define XFldShutdown_xfQueryFldrSort XFolder_xfQueryFldrSort
#define XFldShutdown_xfSetFldrSort XFolder_xfSetFldrSort
#define XFldShutdown_xfSetCnrSort XFolder_xfSetCnrSort
#define XFldShutdown_xfSortViewOnce XFolder_xfSortViewOnce
#define XFldShutdown_xfGetIconPos XFolder_xfGetIconPos
#define XFldShutdown_xfInvalidateOrderedContent XFolder_xfInvalidateOrderedContent
#define XFldShutdown_xfUpdateOrderedContent XFolder_xfUpdateOrderedContent
#define XFldShutdown_xfQueryOrderedContent XFolder_xfQueryOrderedContent
#define XFldShutdown_xfBeginProcessOrderedContent XFolder_xfBeginProcessOrderedContent
#define XFldShutdown_xfCancelProcessOrderedContent XFolder_xfCancelProcessOrderedContent
#define XFldShutdown_xfMakeFavoriteFolder XFolder_xfMakeFavoriteFolder
#define XFldShutdown_xfIsFavoriteFolder XFolder_xfIsFavoriteFolder
#define XFldShutdown_xfSetQuickOpen XFolder_xfSetQuickOpen
#define XFldShutdown_xfQueryQuickOpen XFolder_xfQueryQuickOpen
#define XFldShutdown_xfShowStatusBar XFolder_xfShowStatusBar
#define XFldShutdown_xfSetStatusBarVisibility XFolder_xfSetStatusBarVisibility
#define XFldShutdown_xfQueryStatusBarVisibility XFolder_xfQueryStatusBarVisibility
#define XFldShutdown_xfForEachOpenView XFolder_xfForEachOpenView
#define XFldShutdown_xfAddXFolderPages XFolder_xfAddXFolderPages
#define XFldShutdown_wpSetFldrFlags WPFolder_wpSetFldrFlags
#define XFldShutdown_wpQueryFldrFlags WPFolder_wpQueryFldrFlags
#define XFldShutdown_wpSetFldrFont WPFolder_wpSetFldrFont
#define XFldShutdown_wpQueryFldrFont WPFolder_wpQueryFldrFont
#define XFldShutdown_wpSetFldrAttr WPFolder_wpSetFldrAttr
#define XFldShutdown_wpQueryFldrAttr WPFolder_wpQueryFldrAttr
#define XFldShutdown_wpSetNextIconPos WPFolder_wpSetNextIconPos
#define XFldShutdown_wpQueryNextIconPos WPFolder_wpQueryNextIconPos
#define XFldShutdown_wpPopulate WPFolder_wpPopulate
#define XFldShutdown_wpQueryContent WPFolder_wpQueryContent
#define XFldShutdown_wpAddFolderView1Page WPFolder_wpAddFolderView1Page
#define XFldShutdown_wpAddFolderView2Page WPFolder_wpAddFolderView2Page
#define XFldShutdown_wpAddFolderView3Page WPFolder_wpAddFolderView3Page
#define XFldShutdown_wpAddFolderIncludePage WPFolder_wpAddFolderIncludePage
#define XFldShutdown_wpAddFolderSortPage WPFolder_wpAddFolderSortPage
#define XFldShutdown_wpAddFolderBackgroundPage WPFolder_wpAddFolderBackgroundPage
#define XFldShutdown_wpAddFolderSelfClosePage WPFolder_wpAddFolderSelfClosePage
#define XFldShutdown_wpInitIconPosData WPFolder_wpInitIconPosData
#define XFldShutdown_wpFreeIconPosData WPFolder_wpFreeIconPosData
#define XFldShutdown_wpStoreIconPosData WPFolder_wpStoreIconPosData
#define XFldShutdown_wpQueryIconPosition WPFolder_wpQueryIconPosition
#define XFldShutdown_wpSetFldrSort WPFolder_wpSetFldrSort
#define XFldShutdown_wpQueryFldrSort WPFolder_wpQueryFldrSort
#define XFldShutdown_wpRestoreFldrRunObjs WPFolder_wpRestoreFldrRunObjs
#define XFldShutdown_wpStoreFldrRunObjs WPFolder_wpStoreFldrRunObjs
#define XFldShutdown_wpHideFldrRunObjs WPFolder_wpHideFldrRunObjs
#define XFldShutdown_wpDeleteContents WPFolder_wpDeleteContents
#define XFldShutdown_wpSetFldrDetailsClass WPFolder_wpSetFldrDetailsClass
#define XFldShutdown_wpQueryFldrDetailsClass WPFolder_wpQueryFldrDetailsClass
#define XFldShutdown_wpSearchFolder WPFolder_wpSearchFolder
#define XFldShutdown_wpContainsFolders WPFolder_wpContainsFolders
#define XFldShutdown_wpQueryOpenFolders WPFolder_wpQueryOpenFolders
#define XFldShutdown_wpModifyFldrFlags WPFolder_wpModifyFldrFlags
#define XFldShutdown_wpAddToContent WPFolder_wpAddToContent
#define XFldShutdown_wpDeleteFromContent WPFolder_wpDeleteFromContent
#define XFldShutdown_wpSetDetailsColumnVisibility WPFolder_wpSetDetailsColumnVisibility
#define XFldShutdown_wpIsDetailsColumnVisible WPFolder_wpIsDetailsColumnVisible
#define XFldShutdown_wpSetFldrSortClass WPFolder_wpSetFldrSortClass
#define XFldShutdown_wpQueryFldrSortClass WPFolder_wpQueryFldrSortClass
#define XFldShutdown_wpSetSortAttribAvailable WPFolder_wpSetSortAttribAvailable
#define XFldShutdown_wpIsSortAttribAvailable WPFolder_wpIsSortAttribAvailable
#define XFldShutdown_wpQueryIconViewPos WPFolder_wpQueryIconViewPos
#define XFldShutdown_wpAddFirstChild WPFolder_wpAddFirstChild
#define XFldShutdown_wpSetRealName WPFileSystem_wpSetRealName
#define XFldShutdown_wpSetType WPFileSystem_wpSetType
#define XFldShutdown_wpQueryType WPFileSystem_wpQueryType
#define XFldShutdown_wpSetAttr WPFileSystem_wpSetAttr
#define XFldShutdown_wpQueryAttr WPFileSystem_wpQueryAttr
#define XFldShutdown_wpAddFile1Page WPFileSystem_wpAddFile1Page
#define XFldShutdown_wpAddFile2Page WPFileSystem_wpAddFile2Page
#define XFldShutdown_wpAddFile3Page WPFileSystem_wpAddFile3Page
#define XFldShutdown_wpAddFileMenuPage WPFileSystem_wpAddFileMenuPage
#define XFldShutdown_wpQueryCreation WPFileSystem_wpQueryCreation
#define XFldShutdown_wpQueryLastAccess WPFileSystem_wpQueryLastAccess
#define XFldShutdown_wpQueryLastWrite WPFileSystem_wpQueryLastWrite
#define XFldShutdown_wpQueryFileSize WPFileSystem_wpQueryFileSize
#define XFldShutdown_wpQueryEASize WPFileSystem_wpQueryEASize
#define XFldShutdown_wpSetDateInfo WPFileSystem_wpSetDateInfo
#define XFldShutdown_wpSetFileSizeInfo WPFileSystem_wpSetFileSizeInfo
#define XFldShutdown_wpRefresh WPFileSystem_wpRefresh
#define XFldShutdown_wpQueryRefreshFlags WPFileSystem_wpQueryRefreshFlags
#define XFldShutdown_wpSetRefreshFlags WPFileSystem_wpSetRefreshFlags
#define XFldShutdown_wpPrintPlainTextFile WPFileSystem_wpPrintPlainTextFile
#define XFldShutdown_wpSetTitleAndRenameFile WPFileSystem_wpSetTitleAndRenameFile
#define XFldShutdown_wpConfirmRenameFileWithExt WPFileSystem_wpConfirmRenameFileWithExt
#define XFldShutdown_wpVerifyUpdateAccess WPFileSystem_wpVerifyUpdateAccess
#define XFldShutdown_wpAddUserItemsToPopupMenu WPFileSystem_wpAddUserItemsToPopupMenu
#define XFldShutdown_wpIsDiskSwapped WPFileSystem_wpIsDiskSwapped
#define XFldShutdown_wpQueryRealName WPFileSystem_wpQueryRealName
#define XFldShutdown_wpQueryFilename WPFileSystem_wpQueryFilename
#define XFldShutdown_wpQueryDisk WPFileSystem_wpQueryDisk
#define XFldShutdown_wpQueryDateInfo WPFileSystem_wpQueryDateInfo
#define XFldShutdown_wpConfirmKeepAssoc WPFileSystem_wpConfirmKeepAssoc
#define XFldShutdown_wpAddObjectGeneralPage WPObject_wpAddObjectGeneralPage
#define XFldShutdown_wpAddObjectGeneralPage2 WPObject_wpAddObjectGeneralPage2
#define XFldShutdown_wpAddObjectWindowPage WPObject_wpAddObjectWindowPage
#define XFldShutdown_wpAddSettingsPages WPObject_wpAddSettingsPages
#define XFldShutdown_wpAddToObjUseList WPObject_wpAddToObjUseList
#define XFldShutdown_wpAllocMem WPObject_wpAllocMem
#define XFldShutdown_wpAppendObject WPObject_wpAppendObject
#define XFldShutdown_wpAssertObjectMutexSem WPObject_wpAssertObjectMutexSem
#define XFldShutdown_wpClose WPObject_wpClose
#define XFldShutdown_wpCnrInsertObject WPObject_wpCnrInsertObject
#define XFldShutdown_wpCnrRemoveObject WPObject_wpCnrRemoveObject
#define XFldShutdown_wpCnrSetEmphasis WPObject_wpCnrSetEmphasis
#define XFldShutdown_wpConfirmDelete WPObject_wpConfirmDelete
#define XFldShutdown_wpConfirmObjectTitle WPObject_wpConfirmObjectTitle
#define XFldShutdown_wpCopiedFromTemplate WPObject_wpCopiedFromTemplate
#define XFldShutdown_wpCopyObject WPObject_wpCopyObject
#define XFldShutdown_wpCreateAnother WPObject_wpCreateAnother
#define XFldShutdown_wpCreateFromTemplate WPObject_wpCreateFromTemplate
#define XFldShutdown_wpCreateShadowObject WPObject_wpCreateShadowObject
#define XFldShutdown_wpDelete WPObject_wpDelete
#define XFldShutdown_wpDeleteFromObjUseList WPObject_wpDeleteFromObjUseList
#define XFldShutdown_wpDisplayHelp WPObject_wpDisplayHelp
#define XFldShutdown_wpDisplayMenu WPObject_wpDisplayMenu
#define XFldShutdown_wpDoesObjectMatch WPObject_wpDoesObjectMatch
#define XFldShutdown_wpDraggedOverObject WPObject_wpDraggedOverObject
#define XFldShutdown_wpDragOver WPObject_wpDragOver
#define XFldShutdown_wpDrop WPObject_wpDrop
#define XFldShutdown_wpDroppedOnObject WPObject_wpDroppedOnObject
#define XFldShutdown_wpEndConversation WPObject_wpEndConversation
#define XFldShutdown_wpFilterPopupMenu WPObject_wpFilterPopupMenu
#define XFldShutdown_wpFindUseItem WPObject_wpFindUseItem
#define XFldShutdown_wpFormatDragItem WPObject_wpFormatDragItem
#define XFldShutdown_wpFree WPObject_wpFree
#define XFldShutdown_wpFreeMem WPObject_wpFreeMem
#define XFldShutdown_wpHide WPObject_wpHide
#define XFldShutdown_wpInitData WPObject_wpInitData
#define XFldShutdown_wpInsertPopupMenuItems WPObject_wpInsertPopupMenuItems
#define XFldShutdown_wpInsertSettingsPage WPObject_wpInsertSettingsPage
#define XFldShutdown_wpMenuItemHelpSelected WPObject_wpMenuItemHelpSelected
#define XFldShutdown_wpMenuItemSelected WPObject_wpMenuItemSelected
#define XFldShutdown_wpModifyPopupMenu WPObject_wpModifyPopupMenu
#define XFldShutdown_wpMoveObject WPObject_wpMoveObject
#define XFldShutdown_wpOpen WPObject_wpOpen
#define XFldShutdown_wpPrintObject WPObject_wpPrintObject
#define XFldShutdown_wpQueryConcurrentView WPObject_wpQueryConcurrentView
#define XFldShutdown_wpQueryButtonAppearance WPObject_wpQueryButtonAppearance
#define XFldShutdown_wpQueryConfirmations WPObject_wpQueryConfirmations
#define XFldShutdown_wpQueryDefaultView WPObject_wpQueryDefaultView
#define XFldShutdown_wpQueryDetailsData WPObject_wpQueryDetailsData
#define XFldShutdown_wpQueryError WPObject_wpQueryError
#define XFldShutdown_wpSetFolder WPObject_wpSetFolder
#define XFldShutdown_wpQueryFolder WPObject_wpQueryFolder
#define XFldShutdown_wpQueryIcon WPObject_wpQueryIcon
#define XFldShutdown_wpQueryIconData WPObject_wpQueryIconData
#define XFldShutdown_wpQueryMinWindow WPObject_wpQueryMinWindow
#define XFldShutdown_wpQueryNameClashOptions WPObject_wpQueryNameClashOptions
#define XFldShutdown_wpQueryStyle WPObject_wpQueryStyle
#define XFldShutdown_wpSetTaskRec WPObject_wpSetTaskRec
#define XFldShutdown_wpFindTaskRec WPObject_wpFindTaskRec
#define XFldShutdown_wpQueryTitle WPObject_wpQueryTitle
#define XFldShutdown_wpRegisterView WPObject_wpRegisterView
#define XFldShutdown_wpReleaseObjectMutexSem WPObject_wpReleaseObjectMutexSem
#define XFldShutdown_wpRender WPObject_wpRender
#define XFldShutdown_wpRenderComplete WPObject_wpRenderComplete
#define XFldShutdown_wpReplaceObject WPObject_wpReplaceObject
#define XFldShutdown_wpRequestObjectMutexSem WPObject_wpRequestObjectMutexSem
#define XFldShutdown_wpRestore WPObject_wpRestore
#define XFldShutdown_wpRestoreData WPObject_wpRestoreData
#define XFldShutdown_wpRestoreLong WPObject_wpRestoreLong
#define XFldShutdown_wpRestoreState WPObject_wpRestoreState
#define XFldShutdown_wpRestoreString WPObject_wpRestoreString
#define XFldShutdown_wpSaveData WPObject_wpSaveData
#define XFldShutdown_wpSaveImmediate WPObject_wpSaveImmediate
#define XFldShutdown_wpSaveDeferred WPObject_wpSaveDeferred
#define XFldShutdown_wpSaveLong WPObject_wpSaveLong
#define XFldShutdown_wpSaveState WPObject_wpSaveState
#define XFldShutdown_wpSaveString WPObject_wpSaveString
#define XFldShutdown_wpScanSetupString WPObject_wpScanSetupString
#define XFldShutdown_wpSetConcurrentView WPObject_wpSetConcurrentView
#define XFldShutdown_wpSetButtonAppearance WPObject_wpSetButtonAppearance
#define XFldShutdown_wpSetDefaultHelp WPObject_wpSetDefaultHelp
#define XFldShutdown_wpSetDefaultView WPObject_wpSetDefaultView
#define XFldShutdown_wpSetError WPObject_wpSetError
#define XFldShutdown_wpSetIconHandle WPObject_wpSetIconHandle
#define XFldShutdown_wpQueryScreenGroupID WPObject_wpQueryScreenGroupID
#define XFldShutdown_wpSetupOnce WPObject_wpSetupOnce
#define XFldShutdown_wpSetIcon WPObject_wpSetIcon
#define XFldShutdown_wpSetIconData WPObject_wpSetIconData
#define XFldShutdown_wpSetMinWindow WPObject_wpSetMinWindow
#define XFldShutdown_wpSetStyle WPObject_wpSetStyle
#define XFldShutdown_wpModifyStyle WPObject_wpModifyStyle
#define XFldShutdown_wpSetTitle WPObject_wpSetTitle
#define XFldShutdown_wpSetup WPObject_wpSetup
#define XFldShutdown_wpSwitchTo WPObject_wpSwitchTo
#define XFldShutdown_wpUnInitData WPObject_wpUnInitData
#define XFldShutdown_wpViewObject WPObject_wpViewObject
#define XFldShutdown_wpQueryTrueStyle WPObject_wpQueryTrueStyle
#define XFldShutdown_wpQueryHandle WPObject_wpQueryHandle
#define XFldShutdown_wpUnlockObject WPObject_wpUnlockObject
#define XFldShutdown_wpObjectReady WPObject_wpObjectReady
#define XFldShutdown_wpIsObjectInitialized WPObject_wpIsObjectInitialized
#define XFldShutdown_wpCreateShadowObjectExt WPObject_wpCreateShadowObjectExt
#define XFldShutdown_wpCnrDeleteUseItem WPObject_wpCnrDeleteUseItem
#define XFldShutdown_wpIsDeleteable WPObject_wpIsDeleteable
#define XFldShutdown_wpQueryCoreRecord WPObject_wpQueryCoreRecord
#define XFldShutdown_wpSetObjectID WPObject_wpSetObjectID
#define XFldShutdown_wpQueryObjectID WPObject_wpQueryObjectID
#define XFldShutdown_wpSetDefaultIconPos WPObject_wpSetDefaultIconPos
#define XFldShutdown_wpQueryDefaultIconPos WPObject_wpQueryDefaultIconPos
#define XFldShutdown_wpCnrRefreshDetails WPObject_wpCnrRefreshDetails
#define XFldShutdown_wpFindViewItem WPObject_wpFindViewItem
#define XFldShutdown_wpLockObject WPObject_wpLockObject
#define XFldShutdown_wpIsLocked WPObject_wpIsLocked
#define XFldShutdown_wpQueryContainerFlagPtr WPObject_wpQueryContainerFlagPtr
#define XFldShutdown_wpWaitForClose WPObject_wpWaitForClose
#define XFldShutdown_somDefaultInit SOMObject_somDefaultInit
#define XFldShutdown_somDestruct SOMObject_somDestruct
#define XFldShutdown_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define XFldShutdown_somDefaultAssign SOMObject_somDefaultAssign
#define XFldShutdown_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define XFldShutdown_somDefaultVCopyInit SOMObject_somDefaultVCopyInit
#define XFldShutdown_somDefaultConstVCopyInit SOMObject_somDefaultConstVCopyInit
#define XFldShutdown_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define XFldShutdown_somDefaultVAssign SOMObject_somDefaultVAssign
#define XFldShutdown_somDefaultConstVAssign SOMObject_somDefaultConstVAssign
#define XFldShutdown_somInit SOMObject_somInit
#define XFldShutdown_somFree SOMObject_somFree
#define XFldShutdown_somUninit SOMObject_somUninit
#define XFldShutdown_somGetClass SOMObject_somGetClass
#define XFldShutdown_somGetClassName SOMObject_somGetClassName
#define XFldShutdown_somGetSize SOMObject_somGetSize
#define XFldShutdown_somIsA SOMObject_somIsA
#define XFldShutdown_somIsInstanceOf SOMObject_somIsInstanceOf
#define XFldShutdown_somRespondsTo SOMObject_somRespondsTo
#define XFldShutdown_somDispatch SOMObject_somDispatch
#define XFldShutdown_somClassDispatch SOMObject_somClassDispatch
#define XFldShutdown_somCastObj SOMObject_somCastObj
#define XFldShutdown_somResetObj SOMObject_somResetObj
#define XFldShutdown_somDispatchV SOMObject_somDispatchV
#define XFldShutdown_somDispatchL SOMObject_somDispatchL
#define XFldShutdown_somDispatchA SOMObject_somDispatchA
#define XFldShutdown_somDispatchD SOMObject_somDispatchD
#define XFldShutdown_somPrintSelf SOMObject_somPrintSelf
#define XFldShutdown_somDumpSelf SOMObject_somDumpSelf
#define XFldShutdown_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_XFldShutdown_h */

#ifndef SOM_M_XFldShutdown_h
#define SOM_M_XFldShutdown_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default.
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef M_XFldShutdown
#define M_XFldShutdown SOMObject
#endif
#include <xfldr.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define M_XFldShutdown_MajorVersion 1
#define M_XFldShutdown_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_XFldShutdownNewClass xfshutMc
#pragma linkage(xfshutMc, system)
#define M_XFldShutdownClassData xfshutMd
#define M_XFldShutdownCClassData xfshutMx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_XFldShutdown_classObj M_XFldShutdownClassData.classObject
#define _M_XFldShutdown M_XFldShutdown_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK M_XFldShutdownNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(M_XFldShutdownNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_XFldShutdownClassDataStructure {
	SOMAny *classObject;
} SOMDLINK M_XFldShutdownClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_XFldShutdownCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} SOMDLINK M_XFldShutdownCClassData;

/*
 * New and Renew macros for M_XFldShutdown
 */
#define M_XFldShutdownNew() \
   (_somNew(_M_XFldShutdown ? _M_XFldShutdown : M_XFldShutdownNewClass(M_XFldShutdown_MajorVersion, M_XFldShutdown_MinorVersion)))
#define M_XFldShutdownRenew(buf) \
   (_somRenew(_M_XFldShutdown ? _M_XFldShutdown : M_XFldShutdownNewClass(M_XFldShutdown_MajorVersion, M_XFldShutdown_MinorVersion), buf))

/*
 * Override method: wpclsQueryTitle
 */
#define M_XFldShutdown_wpclsQueryTitle(somSelf) \
	M_WPObject_wpclsQueryTitle(somSelf)

/*
 * Override method: wpclsQueryStyle
 */
#define M_XFldShutdown_wpclsQueryStyle(somSelf) \
	M_WPObject_wpclsQueryStyle(somSelf)

/*
 * Override method: wpclsQueryIconData
 */
#define M_XFldShutdown_wpclsQueryIconData(somSelf,pIconInfo) \
	M_WPObject_wpclsQueryIconData(somSelf,pIconInfo)

/*
 * Override method: wpclsQueryIconDataN
 */
#define M_XFldShutdown_wpclsQueryIconDataN(somSelf,pIconInfo,ulIconIndex) \
	M_WPFolder_wpclsQueryIconDataN(somSelf,pIconInfo,ulIconIndex)
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define M_XFldShutdown_xfclsForEachOpenView M_XFolder_xfclsForEachOpenView
#define M_XFldShutdown_xfclsQueryFavoriteFolder M_XFolder_xfclsQueryFavoriteFolder
#define M_XFldShutdown_xfclsQueryQuickOpenFolder M_XFolder_xfclsQueryQuickOpenFolder
#define M_XFldShutdown_xfclsSetDefaultTitle M_XFolder_xfclsSetDefaultTitle
#define M_XFldShutdown_wpclsQueryIconN M_WPFolder_wpclsQueryIconN
#define M_XFldShutdown_wpclsQueryOpenFolders M_WPFolder_wpclsQueryOpenFolders
#define M_XFldShutdown_wpclsQueryAwakeObject M_WPFileSystem_wpclsQueryAwakeObject
#define M_XFldShutdown_wpclsFileSysExists M_WPFileSystem_wpclsFileSysExists
#define M_XFldShutdown_wpclsQueryObjectFromPath M_WPFileSystem_wpclsQueryObjectFromPath
#define M_XFldShutdown_wpclsQueryInstanceType M_WPFileSystem_wpclsQueryInstanceType
#define M_XFldShutdown_wpclsQueryInstanceFilter M_WPFileSystem_wpclsQueryInstanceFilter
#define M_XFldShutdown_wpclsCreateDefaultTemplates M_WPObject_wpclsCreateDefaultTemplates
#define M_XFldShutdown_wpclsInitData M_WPObject_wpclsInitData
#define M_XFldShutdown_wpclsMakeAwake M_WPObject_wpclsMakeAwake
#define M_XFldShutdown_wpclsNew M_WPObject_wpclsNew
#define M_XFldShutdown_wpclsQueryDefaultHelp M_WPObject_wpclsQueryDefaultHelp
#define M_XFldShutdown_wpclsQueryDefaultView M_WPObject_wpclsQueryDefaultView
#define M_XFldShutdown_wpclsQueryDetails M_WPObject_wpclsQueryDetails
#define M_XFldShutdown_wpclsQueryDetailsInfo M_WPObject_wpclsQueryDetailsInfo
#define M_XFldShutdown_wpclsQueryExtendedCriteria M_WPObject_wpclsQueryExtendedCriteria
#define M_XFldShutdown_wpclsQueryFolder M_WPObject_wpclsQueryFolder
#define M_XFldShutdown_wpclsQueryIcon M_WPObject_wpclsQueryIcon
#define M_XFldShutdown_wpclsQuerySearchInfo M_WPObject_wpclsQuerySearchInfo
#define M_XFldShutdown_wpclsUnInitData M_WPObject_wpclsUnInitData
#define M_XFldShutdown_wpclsFindObjectFirst M_WPObject_wpclsFindObjectFirst
#define M_XFldShutdown_wpclsFindObjectNext M_WPObject_wpclsFindObjectNext
#define M_XFldShutdown_wpclsFindObjectEnd M_WPObject_wpclsFindObjectEnd
#define M_XFldShutdown_wpclsSetError M_WPObject_wpclsSetError
#define M_XFldShutdown_wpclsQueryError M_WPObject_wpclsQueryError
#define M_XFldShutdown_wpclsQuerySettingsPageSize M_WPObject_wpclsQuerySettingsPageSize
#define M_XFldShutdown_wpclsQueryObject M_WPObject_wpclsQueryObject
#define M_XFldShutdown_wpclsQueryButtonAppearance M_WPObject_wpclsQueryButtonAppearance
#define M_XFldShutdown_wpclsDecUsage M_WPObject_wpclsDecUsage
#define M_XFldShutdown_wpclsIncUsage M_WPObject_wpclsIncUsage
#define M_XFldShutdown_wpclsInsertMultipleObjects M_WPObject_wpclsInsertMultipleObjects
#define M_XFldShutdown_wpclsFindOneObject M_WPObject_wpclsFindOneObject
#define M_XFldShutdown_wpclsSetSettingsPageSize M_WPObject_wpclsSetSettingsPageSize
#define M_XFldShutdown_wpclsSetIconData M_WPObject_wpclsSetIconData
#define M_XFldShutdown_wpclsSetIcon M_WPObject_wpclsSetIcon
#define M_XFldShutdown_wpclsObjectFromHandle M_WPObject_wpclsObjectFromHandle
#define M_XFldShutdown_wpclsRemoveObjects M_WPObject_wpclsRemoveObjects
#define M_XFldShutdown__get_somDataAlignment SOMClass__get_somDataAlignment
#define M_XFldShutdown__get_somInstanceDataOffsets SOMClass__get_somInstanceDataOffsets
#define M_XFldShutdown__get_somDirectInitClasses SOMClass__get_somDirectInitClasses
#define M_XFldShutdown__set_somDirectInitClasses SOMClass__set_somDirectInitClasses
#define M_XFldShutdown_somNew SOMClass_somNew
#define M_XFldShutdown_somNewNoInit SOMClass_somNewNoInit
#define M_XFldShutdown_somRenew SOMClass_somRenew
#define M_XFldShutdown_somRenewNoInit SOMClass_somRenewNoInit
#define M_XFldShutdown_somRenewNoZero SOMClass_somRenewNoZero
#define M_XFldShutdown_somRenewNoInitNoZero SOMClass_somRenewNoInitNoZero
#define M_XFldShutdown_somAllocate SOMClass_somAllocate
#define M_XFldShutdown_somDeallocate SOMClass_somDeallocate
#define M_XFldShutdown__get_somClassAllocate SOMClass__get_somClassAllocate
#define M_XFldShutdown__get_somClassDeallocate SOMClass__get_somClassDeallocate
#define M_XFldShutdown_somGetInstanceInitMask SOMClass_somGetInstanceInitMask
#define M_XFldShutdown_somGetInstanceDestructionMask SOMClass_somGetInstanceDestructionMask
#define M_XFldShutdown_somGetInstanceAssignmentMask SOMClass_somGetInstanceAssignmentMask
#define M_XFldShutdown_somInitClass SOMClass_somInitClass
#define M_XFldShutdown_somInitMIClass SOMClass_somInitMIClass
#define M_XFldShutdown_somAddStaticMethod SOMClass_somAddStaticMethod
#define M_XFldShutdown_somAddDynamicMethod SOMClass_somAddDynamicMethod
#define M_XFldShutdown_somOverrideSMethod SOMClass_somOverrideSMethod
#define M_XFldShutdown_somClassReady SOMClass_somClassReady
#define M_XFldShutdown_somGetApplyStub SOMClass_somGetApplyStub
#define M_XFldShutdown_somGetClassData SOMClass_somGetClassData
#define M_XFldShutdown_somSetClassData SOMClass_somSetClassData
#define M_XFldShutdown_somGetClassMtab SOMClass_somGetClassMtab
#define M_XFldShutdown_somGetInstanceOffset SOMClass_somGetInstanceOffset
#define M_XFldShutdown_somGetInstancePartSize SOMClass_somGetInstancePartSize
#define M_XFldShutdown_somGetInstanceSize SOMClass_somGetInstanceSize
#define M_XFldShutdown_somGetInstanceToken SOMClass_somGetInstanceToken
#define M_XFldShutdown_somGetMemberToken SOMClass_somGetMemberToken
#define M_XFldShutdown_somGetMethodData SOMClass_somGetMethodData
#define M_XFldShutdown_somGetRdStub SOMClass_somGetRdStub
#define M_XFldShutdown_somGetMethodDescriptor SOMClass_somGetMethodDescriptor
#define M_XFldShutdown_somGetMethodIndex SOMClass_somGetMethodIndex
#define M_XFldShutdown_somGetMethodToken SOMClass_somGetMethodToken
#define M_XFldShutdown_somGetName SOMClass_somGetName
#define M_XFldShutdown_somGetNthMethodData SOMClass_somGetNthMethodData
#define M_XFldShutdown_somGetNthMethodInfo SOMClass_somGetNthMethodInfo
#define M_XFldShutdown_somGetNumMethods SOMClass_somGetNumMethods
#define M_XFldShutdown_somGetNumStaticMethods SOMClass_somGetNumStaticMethods
#define M_XFldShutdown_somGetParent SOMClass_somGetParent
#define M_XFldShutdown_somGetParents SOMClass_somGetParents
#define M_XFldShutdown_somGetPClsMtab SOMClass_somGetPClsMtab
#define M_XFldShutdown_somGetPClsMtabs SOMClass_somGetPClsMtabs
#define M_XFldShutdown_somGetVersionNumbers SOMClass_somGetVersionNumbers
#define M_XFldShutdown_somSetMethodDescriptor SOMClass_somSetMethodDescriptor
#define M_XFldShutdown_somFindMethod SOMClass_somFindMethod
#define M_XFldShutdown_somFindMethodOk SOMClass_somFindMethodOk
#define M_XFldShutdown_somFindSMethod SOMClass_somFindSMethod
#define M_XFldShutdown_somFindSMethodOk SOMClass_somFindSMethodOk
#define M_XFldShutdown_somLookupMethod SOMClass_somLookupMethod
#define M_XFldShutdown_somCheckVersion SOMClass_somCheckVersion
#define M_XFldShutdown_somDescendedFrom SOMClass_somDescendedFrom
#define M_XFldShutdown_somSupportsMethod SOMClass_somSupportsMethod
#define M_XFldShutdown_somDefinedMethod SOMClass_somDefinedMethod
#define M_XFldShutdown_somOverrideMtab SOMClass_somOverrideMtab
#define M_XFldShutdown_somDefaultInit SOMObject_somDefaultInit
#define M_XFldShutdown_somDestruct SOMObject_somDestruct
#define M_XFldShutdown_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define M_XFldShutdown_somDefaultAssign SOMObject_somDefaultAssign
#define M_XFldShutdown_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define M_XFldShutdown_somDefaultVCopyInit SOMObject_somDefaultVCopyInit
#define M_XFldShutdown_somDefaultConstVCopyInit SOMObject_somDefaultConstVCopyInit
#define M_XFldShutdown_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define M_XFldShutdown_somDefaultVAssign SOMObject_somDefaultVAssign
#define M_XFldShutdown_somDefaultConstVAssign SOMObject_somDefaultConstVAssign
#define M_XFldShutdown_somInit SOMObject_somInit
#define M_XFldShutdown_somFree SOMObject_somFree
#define M_XFldShutdown_somUninit SOMObject_somUninit
#define M_XFldShutdown_somGetClass SOMObject_somGetClass
#define M_XFldShutdown_somGetClassName SOMObject_somGetClassName
#define M_XFldShutdown_somGetSize SOMObject_somGetSize
#define M_XFldShutdown_somIsA SOMObject_somIsA
#define M_XFldShutdown_somIsInstanceOf SOMObject_somIsInstanceOf
#define M_XFldShutdown_somRespondsTo SOMObject_somRespondsTo
#define M_XFldShutdown_somDispatch SOMObject_somDispatch
#define M_XFldShutdown_somClassDispatch SOMObject_somClassDispatch
#define M_XFldShutdown_somCastObj SOMObject_somCastObj
#define M_XFldShutdown_somResetObj SOMObject_somResetObj
#define M_XFldShutdown_somDispatchV SOMObject_somDispatchV
#define M_XFldShutdown_somDispatchL SOMObject_somDispatchL
#define M_XFldShutdown_somDispatchA SOMObject_somDispatchA
#define M_XFldShutdown_somDispatchD SOMObject_somDispatchD
#define M_XFldShutdown_somPrintSelf SOMObject_somPrintSelf
#define M_XFldShutdown_somDumpSelf SOMObject_somDumpSelf
#define M_XFldShutdown_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_M_XFldShutdown_h */
